import * as i0 from '@angular/core';
import { Injectable, Component, ViewChild, Inject, PLATFORM_ID, NgModule } from '@angular/core';
import { lastValueFrom, Subject } from 'rxjs';
import * as i1 from '@angular/common/http';
import FeatureLayer from '@arcgis/core/layers/FeatureLayer';
import WebMap from '@arcgis/core/WebMap';
import BasemapGallery from '@arcgis/core/widgets/BasemapGallery';
import PortalBasemapsSource from '@arcgis/core/widgets/BasemapGallery/support/PortalBasemapsSource';
import Compass from '@arcgis/core/widgets/Compass.js';
import CoordinateConversion from '@arcgis/core/widgets/CoordinateConversion';
import Expand from '@arcgis/core/widgets/Expand';
import Home from '@arcgis/core/widgets/Home';
import Legend from '@arcgis/core/widgets/Legend';
import Locate from '@arcgis/core/widgets/Locate';
import Graphic from '@arcgis/core/Graphic';
import * as reactiveUtils from '@arcgis/core/core/reactiveUtils.js';
import Portal from '@arcgis/core/portal/Portal';
import ScaleBar from '@arcgis/core/widgets/ScaleBar';
import SimpleMarkerSymbol from '@arcgis/core/symbols/SimpleMarkerSymbol';
import MapView from '@arcgis/core/views/MapView';
import Search from '@arcgis/core/widgets/Search';
import Bookmarks from '@arcgis/core/widgets/Bookmarks.js';
import Bookmark from '@arcgis/core/webmap/Bookmark.js';
import Extent from '@arcgis/core/geometry/Extent';
import Basemap from '@arcgis/core/Basemap';
import LayerList from '@arcgis/core/widgets/LayerList';
import TimeSlider from '@arcgis/core/widgets/TimeSlider';
import TimeInterval from '@arcgis/core/TimeInterval';
import Layer from '@arcgis/core/layers/Layer.js';
import PrintTemplate from '@arcgis/core/rest/support/PrintTemplate';
import * as print from '@arcgis/core/rest/print';
import PrintParameters from '@arcgis/core/rest/support/PrintParameters';
import * as Locator from '@arcgis/core/rest/locator';
import esriId from '@arcgis/core/identity/IdentityManager';
import * as i2 from '@angular/router';
import * as i3 from '@angular/cdk/drag-drop';
import { DragDropModule } from '@angular/cdk/drag-drop';
import * as i3$1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import * as i5 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i6 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i5$1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i4 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5$2 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i6$1 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import * as i7 from '@angular/forms';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i9 from '@angular/common';
import { isPlatformBrowser, DatePipe, CommonModule } from '@angular/common';
import * as i12 from '@angular/material/table';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import * as i10 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import * as i11 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import * as am5 from '@amcharts/amcharts5';
import * as am5flow from '@amcharts/amcharts5/flow';
import * as am5percent from '@amcharts/amcharts5/percent';
import am5themes_Animated from '@amcharts/amcharts5/themes/Animated';
import am5themes_Responsive from '@amcharts/amcharts5/themes/Responsive';
import * as am5xy from '@amcharts/amcharts5/xy';
import GraphicsLayer from '@arcgis/core/layers/GraphicsLayer';
import * as _ from 'lodash';
import * as i4$1 from '@angular/cdk/bidi';
import { NgxSpinnerModule } from 'ngx-spinner';
import { A11yModule } from '@angular/cdk/a11y';
import { PortalModule } from '@angular/cdk/portal';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatBadgeModule } from '@angular/material/badge';
import { MatBottomSheetModule } from '@angular/material/bottom-sheet';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCardModule } from '@angular/material/card';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatChipsModule } from '@angular/material/chips';
import { MatStepperModule } from '@angular/material/stepper';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatDividerModule } from '@angular/material/divider';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatListModule } from '@angular/material/list';
import { MatMenuModule } from '@angular/material/menu';
import { MatNativeDateModule, MatRippleModule } from '@angular/material/core';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatRadioModule } from '@angular/material/radio';
import { MatSelectModule } from '@angular/material/select';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatSliderModule } from '@angular/material/slider';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatTabsModule } from '@angular/material/tabs';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatTreeModule } from '@angular/material/tree';

class MyAngularGptPackageService {
    constructor() { }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

class MyAngularGptPackageComponent {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.4", type: MyAngularGptPackageComponent, isStandalone: true, selector: "lib-my-angular-gpt-package", ngImport: i0, template: `
    <p>
      my-angular-gpt-package works!
    </p>
  `, isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-my-angular-gpt-package', imports: [], template: `
    <p>
      my-angular-gpt-package works!
    </p>
  ` }]
        }] });

class AppConfig {
    portalUrl = "";
    appId = "";
    portalUsername = "";
    portalPassword = "";
    portalGenerateTokenUrl = "";
    portalRefererUrl = "";
    authenticationType = "";
    allowAnonymous = false;
    defaultLanguage = "";
    selectedLanguage = "";
}

class MapConfig {
    mapMode = "";
    webmapId = "";
}

class WebApiConfig {
    layersConfig = {};
    mapLayers = {};
    mapConfig = new MapConfig();
    appName = '';
    geoGptUrl = '';
    geoCodeUrl = '';
    saveMapUrl = '';
    printMapUrl = '';
}

class ApplicationConfig {
    appConfig = new AppConfig();
    webapiConfig = new WebApiConfig();
    mapView;
    resources;
}

class ConfigService {
    http;
    config = new ApplicationConfig();
    constructor(http) {
        this.http = http;
    }
    async loadConfig(jsonPath, resourcesPath) {
        try {
            this.config = await lastValueFrom(this.http.get(jsonPath));
            this.config.resources = await this.getResources(resourcesPath, this.getLanguage(this.config.appConfig.defaultLanguage));
            console.log('Library Config Loaded', this.config);
        }
        catch (error) {
            console.error('Error loading config:', error);
        }
    }
    async getResources(resourcesPath, lang) {
        let resources = await this.http.get(`${resourcesPath}?d=${Date.now()}`).toPromise();
        return this.fillResources(lang, resources);
    }
    getLanguage(defaultLanguage) {
        let urlParams = new URLSearchParams(window.location.search);
        let language = urlParams.get('locale') || localStorage.getItem("locale");
        if (language == null) {
            language = defaultLanguage;
        }
        return language;
    }
    fillResources(lang, resources) {
        let urlParams = new URLSearchParams(window.location.search);
        let langResources = {};
        if (urlParams.has("lang")) {
            lang = urlParams.get("lang");
        }
        var length = resources.length;
        for (var i = 0; i < length; i++) {
            if (resources[i]["key"] != "") {
                langResources[resources[i]["key"]] = resources[i][lang];
            }
        }
        return langResources;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ConfigService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ConfigService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [{ type: i1.HttpClient }] });

class EventsService {
    // app loadnig
    loadAppEventSubject = new Subject();
    loadAppEvent = this.loadAppEventSubject.asObservable();
    // map loading
    mapLoadedEventSubject = new Subject();
    mapLoadedEvent = this.mapLoadedEventSubject.asObservable();
    // reset map filter
    resetMapFiltersEventSubject = new Subject();
    resetMapFiltersEvent = this.resetMapFiltersEventSubject.asObservable();
    // estidama feature
    estidamaFeaturesEventSubject = new Subject();
    estidamaFeaturesEvent = this.estidamaFeaturesEventSubject.asObservable();
    // charts printing
    chartsPrintingEventSubject = new Subject();
    chartsPrintingEvent = this.chartsPrintingEventSubject.asObservable();
    // selected chart column
    selectedChartColumnEventSubject = new Subject();
    selectedChartColumnDataEvent = this.selectedChartColumnEventSubject.asObservable();
    // reports charts data
    reportsChartsDataEventSubject = new Subject();
    reportsChartsDataEvent = this.reportsChartsDataEventSubject.asObservable();
    // zoom to report data on map
    viewReportDataOnMapEventSubject = new Subject();
    viewReportDataOnMapEvent = this.viewReportDataOnMapEventSubject.asObservable();
    // target layer
    selectedTargetLayerEventSubject = new Subject();
    selectedTargetLayerDataEvent = this.selectedTargetLayerEventSubject.asObservable();
    // selected year
    selectedYearEventSubject = new Subject();
    selectedYearDataEvent = this.selectedYearEventSubject.asObservable();
    openedExpandWidgetNameEventSubject = new Subject();
    openedExpandWidgetNameLoadedEvent = this.openedExpandWidgetNameEventSubject.asObservable();
    constructor() { }
    loadApp = (load) => {
        try {
            this.loadAppEventSubject.next(load);
        }
        catch (error) {
            console.error('Error in loadApp:', error);
        }
    };
    mapLoaded = (load) => {
        try {
            this.mapLoadedEventSubject.next(load);
        }
        catch (error) {
            console.error('Error in mapLoaded:', error);
        }
    };
    selectedChartColumn = (chartColumn) => {
        try {
            this.selectedChartColumnEventSubject.next(chartColumn);
        }
        catch (error) {
            console.error('Error in selectedChartColumn:', error);
        }
    };
    resetMapFilters = (load) => {
        try {
            this.resetMapFiltersEventSubject.next(load);
        }
        catch (error) {
            console.error('Error in resetMapFilters:', error);
        }
    };
    estidamaFeaturesToShow = (showEstidama) => {
        try {
            this.estidamaFeaturesEventSubject.next(showEstidama);
        }
        catch (error) {
            console.error('Error in estidamaFeaturesToShow:', error);
        }
    };
    reportsChartsData = (chartsData) => {
        try {
            this.reportsChartsDataEventSubject.next(chartsData);
        }
        catch (error) {
        }
    };
    chartsPrinting = (print) => {
        try {
            this.chartsPrintingEventSubject.next(print);
        }
        catch (error) {
            console.error('Error in chartsPrinting:', error);
        }
    };
    openUrl = (url) => {
        try {
            const win = window.open(url, '_blank');
            win.focus();
        }
        catch (error) {
            console.error('Error in openUrl:', error);
        }
    };
    selectedTargetLayer = (newTargetLayerSelected) => {
        try {
            this.selectedTargetLayerEventSubject.next(newTargetLayerSelected);
        }
        catch (error) {
            console.error('Error in selectedTargetLayer:', error);
        }
    };
    viewReportDataOnMap = (viewReportDataOnMap) => {
        try {
            this.viewReportDataOnMapEventSubject.next(viewReportDataOnMap);
        }
        catch (error) {
            console.error('Error in viewReportDataOnMap:', error);
        }
    };
    selectedYear = (newYearSelected) => {
        try {
            this.selectedYearEventSubject.next(newYearSelected);
        }
        catch (error) {
            console.error('Error in selectedYear:', error);
        }
    };
    openExpandWidgetName(expandWidgetName) {
        this.openedExpandWidgetNameEventSubject.next(expandWidgetName);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: EventsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: EventsService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: EventsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

class IdentityService {
    http;
    route;
    configService;
    constructor(http, route, configService) {
        this.http = http;
        this.route = route;
        this.configService = configService;
    }
    registerArcGISToken(token) {
        console.log('Token generated:', token);
        let url = this.configService.config.appConfig.portalUrl + "sharing/rest";
        esriId.registerToken({ server: url, token: token, ssl: true });
        console.log('Token registered');
    }
    async generateArcGISToken() {
        try {
            const portalUrl = this.configService.config.appConfig.portalUrl;
            const username = this.configService.config.appConfig.portalUsername;
            const password = this.configService.config.appConfig.portalPassword;
            const portalGenerateTokenUrl = this.configService.config.appConfig.portalGenerateTokenUrl;
            const portalRefererUrl = this.configService.config.appConfig.portalRefererUrl;
            // Define parameters for token request
            const params = new URLSearchParams();
            params.append('f', 'json'); // Response format
            params.append('username', username); // Your ArcGIS Portal username
            params.append('password', password); // Your ArcGIS Portal password
            params.append('referer', portalRefererUrl); // Referer URL (important for some ArcGIS servers)
            params.append('expiration', '60'); // Token expiration time in minutes (optional)
            params.append('request', 'getToken'); // Client type ('referer' for web app requests)
            const response = await fetch(portalGenerateTokenUrl, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                body: params
            });
            // Check if the response is ok (status code 200-299)
            if (!response.ok) {
                return `Error generating token: ${response.statusText}`;
            }
            // Parse the JSON response
            const data = await response.json();
            // Check for token in the response
            if (data.token) {
                return data.token;
            }
            else {
                return `Token generation failed: ${data.error.message}`;
            }
        }
        catch (error) {
            console.error('Error:', error);
            return `Error generating token: ${error.message}`;
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: IdentityService, deps: [{ token: i1.HttpClient }, { token: i2.Router }, { token: ConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: IdentityService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: IdentityService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [{ type: i1.HttpClient }, { type: i2.Router }, { type: ConfigService }] });

class ArcgisService {
    configService;
    eventsService;
    identityService;
    config;
    searchWidget;
    otherHighlightedFeatures = [];
    plotHighlightedFeatures;
    viewBuildingFeatureMap = false;
    mapExpandsWidget = [];
    basemapGalleryExpand;
    legendExpand;
    coordinateConversionExpand;
    sketchExpand;
    toolbarDivExpand;
    mapScaleDivExpand;
    symbolBuilderExpand;
    bookmarks;
    layerListExpand; // Reference to the layer list expand widget
    legend = null;
    _prevExtent = false;
    _nextExtent = false;
    _currentExtent;
    _extentHistory = [];
    _extentHistoryIndx = 0;
    _preExtent;
    layersConfig;
    initialExtent;
    // private viewContent: ViewContainerRef
    constructor(configService, eventsService, identityService) {
        this.configService = configService;
        this.eventsService = eventsService;
        this.identityService = identityService;
        this.config = configService.config;
    }
    initializeMap = async (appConfig, itemid, mapViewEl) => {
        try {
            const token = await this.identityService.generateArcGISToken();
            console.log('token generated', token);
            await this.identityService.registerArcGISToken(token);
            console.log('Initializing map with appConfig.portalUrl:', appConfig.portalUrl);
            // Create WebMap with authentication
            let webmap = new WebMap({
                portalItem: {
                    // autocasts as new PortalItem()
                    id: itemid,
                    portal: {
                        url: appConfig.portalUrl,
                    },
                },
            });
            console.log('WebMap is ready with authentication!');
            let mapView = new MapView({
                map: webmap,
                container: mapViewEl.nativeElement,
            });
            // Add secure feature layers
            this.configService.config.webapiConfig.mapLayers.forEach((layer) => {
                let featureLayer = new FeatureLayer({
                    url: layer.url, // Use the generated token
                    title: layer.layerNameInMap
                });
                console.log('Adding secure layer:', featureLayer.url);
                webmap.add(featureLayer);
            });
            mapView.ui.remove('attribution');
            this.configService.config.mapView = mapView;
            console.log('MapView initialized successfully');
            return mapView;
        }
        catch (error) {
            console.error("Error initializing map:", error);
            return new MapView();
        }
    };
    addWidgetsOnScreen(config, mapView) {
        let location = config.appConfig.selectedLanguage.toLowerCase() == 'en'
            ? 'left'
            : 'right';
        //home
        let homeWidget = new Home({
            view: mapView,
            container: this.createComponentContainer(false),
        });
        mapView.ui.add(homeWidget, 'top-' + location);
        // zoom
        mapView.ui.move('zoom', 'top-' + location);
        // compass
        let compass = new Compass({
            view: mapView,
        });
        mapView.ui.add(compass, 'top-' + location);
        this.addLayerList(mapView);
        this.addLegendList(mapView);
        let basemapGallery = new BasemapGallery({
            view: mapView,
            source: new PortalBasemapsSource({
                portal: new Portal({ url: config.appConfig.portalUrl }),
            }),
        });
        basemapGallery.watch('activeBasemap', (newValue, oldValue, property, object) => {
            //log
        });
        this.basemapGalleryExpand = new Expand({
            id: 'basemapGalleryExpand',
            expandIcon: 'basemap',
            view: mapView,
            content: basemapGallery,
            expandTooltip: this.config.resources.basemapGalleryExpandTooltip,
            mode: 'floating',
        });
        mapView.ui.add(this.basemapGalleryExpand, 'top-' + location);
        let locate = new Locate({
            view: mapView,
            graphic: new Graphic({
                symbol: new SimpleMarkerSymbol({ color: '#aa182c' }),
            }),
            container: this.createComponentContainer(false),
        });
        locate.on('locate', () => {
            //log
        });
        mapView.ui.add(locate, 'top-' + location);
        let scaleBar = new ScaleBar({
            view: mapView,
            unit: 'metric',
        });
        mapView.ui.add(scaleBar, 'bottom-' + location);
        let coordinateConversion = new CoordinateConversion({
            view: mapView,
        });
        this.removeUnwantedFormats(coordinateConversion);
        this.coordinateConversionExpand = new Expand({
            id: 'coordinateConversionExpand',
            view: mapView,
            content: coordinateConversion,
            expandIcon: 'pop-up-blank',
            expandTooltip: this.config.resources.coordinateConversionExpandTooltip,
            container: this.createComponentContainer(true),
        });
        mapView.ui.add(this.coordinateConversionExpand, 'top-' + location);
        this.coordinateConversionExpand.watch('expanded', (newValue) => {
            if (newValue) {
                //log
            }
        });
        // add listeners to the expand widgets
        this.mapExpandsWidget.push(this.basemapGalleryExpand);
        reactiveUtils.watch(() => this.basemapGalleryExpand.expanded, () => {
            if (this.basemapGalleryExpand.expanded) {
                this.eventsService.openExpandWidgetName('basemapGalleryExpand');
            }
        });
        this.mapExpandsWidget.push(this.legendExpand);
        reactiveUtils.watch(() => this.legendExpand.expanded, () => {
            if (this.legendExpand.expanded) {
                this.eventsService.openExpandWidgetName('legendExpand');
            }
        });
        this.mapExpandsWidget.push(this.coordinateConversionExpand);
        reactiveUtils.watch(() => this.coordinateConversionExpand.expanded, () => {
            if (this.coordinateConversionExpand.expanded) {
                this.eventsService.openExpandWidgetName('coordinateConversionExpand');
            }
        });
        this.setExpandWidgetsToggleListener();
        const searchWidget = new Search({
            view: mapView,
        });
        const searchLocation = config.appConfig.selectedLanguage.toLowerCase() == 'en'
            ? 'right'
            : 'left';
        // Add the search widget to the top right corner of the view
        mapView.ui.add(searchWidget, 'top-' + searchLocation);
    }
    createComponentContainer(hideInMobileView) {
        let esriComponentContainer = document.createElement('div');
        if (hideInMobileView) {
            esriComponentContainer.classList.add('mobile-hidden');
        }
        return esriComponentContainer;
    }
    removeUnwantedFormats = (coordinateConversionWidget) => {
        this.eventsService.mapLoadedEventSubject.subscribe((mapLoaded) => {
            coordinateConversionWidget.formats.removeMany(coordinateConversionWidget.formats.filter((format) => format.name.toLowerCase() == 'ddm' ||
                format.name.toLowerCase() == 'usng'));
        });
    };
    trackingg = (mapView) => {
        reactiveUtils
            .whenOnce(() => mapView.ready)
            .then(() => {
            // Listen for changes in the extent when the map is stationary
            reactiveUtils.when(() => mapView.stationary, () => {
                this.extentChangeHandler(mapView.extent);
            });
        });
    };
    // Method to change the basemap
    switchBasemap(mapView, basemapName) {
        if (mapView.map) {
            const basemap = Basemap.fromId(basemapName);
            if (basemap) {
                mapView.map.basemap = basemap;
            }
            else {
                console.error(`Basemap with name '${basemapName}' not found.`);
            }
        }
    }
    extentChangeHandler = (evt) => {
        try {
            if (this._prevExtent || this._nextExtent) {
                this._currentExtent = evt;
            }
            else {
                this._preExtent = this._currentExtent;
                this._currentExtent = evt;
                this._extentHistory.push({
                    preExtent: this._preExtent,
                    currentExtent: this._currentExtent,
                });
                this._extentHistoryIndx = this._extentHistory.length - 1;
            }
            this._prevExtent = this._nextExtent = false;
        }
        catch (error) {
            console.error(error);
        }
    };
    // Method to increase zoom
    increaseZoom(mapView, increment = 1) {
        mapView.zoom += increment;
    }
    // Method to decrease zoom
    decreaseZoom(mapView, decrement = 1) {
        mapView.zoom -= decrement;
    }
    zoomToPrevious = (mapView) => {
        if (!(this._extentHistory.length === 0 || this._extentHistoryIndx === 0)) {
            this._prevExtent = true;
            mapView.goTo(this._extentHistory[this._extentHistoryIndx].preExtent);
            this._extentHistoryIndx--;
            return 'Zoomed to Previous Extent';
        }
        else {
            return 'No Previous Extent';
        }
    };
    zoomToNext = (mapView) => {
        if (!(this._extentHistory.length === 0 ||
            this._extentHistoryIndx === this._extentHistory.length - 1)) {
            this._nextExtent = true;
            this._extentHistoryIndx++;
            mapView.goTo(this._extentHistory[this._extentHistoryIndx].currentExtent);
            return 'Zoomed to Next Extent';
        }
        else {
            return 'No Next Extent';
        }
    };
    async addLayerFromURL(mapView, url) {
        const l = await Layer.fromArcGISServerUrl({ url: url });
        // Check if the layer already exists  
        if (!this.layerExists(url, mapView.map)) {
            mapView.map.add(l);
            l.when(() => {
                // Ensure the layer is loaded before trying to access its extent  
                if (l.fullExtent) {
                    mapView.goTo(l.fullExtent).catch((error) => {
                        console.error('Error zooming to layer extent:', error);
                    });
                }
                else {
                    console.warn('Layer does not have a fullExtent property.');
                }
            }).catch((error) => {
                console.error('Error loading layer:', error);
            });
        }
        else {
            console.log('Layer already exists in the map:', url);
        }
        console.log(url);
        console.log(mapView.map.allLayers);
    }
    layerExists(url, map) {
        return Array.from(map.allLayers).some((layer) => layer.url === url);
    }
    removeLayerByTitle = (mapView, layerTitle) => {
        const layer = mapView.map.layers.find((l) => l.title === layerTitle);
        if (layer) {
            mapView.map.remove(layer);
        }
    };
    // Method to add the layer list to the map
    addLayerList(mapView) {
        // Check if the layerListExpand already exists  
        if (this.layerListExpand) {
            console.log('LayerList is already added to the UI.');
            return; // Exit if it already exists  
        }
        const layerList = new LayerList({
            view: mapView,
        });
        this.layerListExpand = new Expand({
            view: mapView,
            content: layerList,
        });
        mapView.ui.add(this.layerListExpand, 'top-left');
        console.log('LayerList added to the UI.');
    }
    // Method to remove the layer list from the map
    removeLayerList(mapView) {
        if (this.layerListExpand) {
            mapView.ui.remove(this.layerListExpand);
            this.layerListExpand.destroy(); // Optional: Destroy the widget to clean up resources
            this.layerListExpand = undefined; // Reset the reference
        }
        else {
            //console.error('Layer list is not added to the map.');
        }
    }
    // Method to add the legend list to the map
    addLegendList(mapView) {
        // Check if the legendExpand already exists  
        if (this.legendExpand) {
            console.log('Legend is already added to the UI.');
            return; // Exit if it already exists  
        }
        // Create the Legend and Expand widget  
        this.legend = new Legend({
            view: mapView,
        });
        this.legendExpand = new Expand({
            view: mapView,
            content: this.legend,
        });
        mapView.ui.add(this.legendExpand, 'top-left');
        console.log('Legend added to the UI.');
    }
    // Method to remove the legend list from the map
    removeLegendList(mapView) {
        if (this.legendExpand) {
            mapView.ui.remove(this.legendExpand);
            this.legendExpand.destroy(); // Optional: Destroy the widget to clean up resources
            this.legendExpand = undefined; // Reset the reference
        }
        else {
            //console.error('Legend is not added to the map.');
        }
    }
    applyExportFunction(mapView) {
        mapView
            .takeScreenshot()
            .then((screenshot) => {
            // Create an <a> element to download the screenshot
            const a = document.createElement('a');
            a.href = screenshot.dataUrl;
            a.download = 'map-screenshot.png';
            document.body.appendChild(a);
            a.click();
            document.body.removeChild(a);
        })
            .catch((error) => {
            //console.error('Error taking screenshot:', error);
        });
    }
    getLayerByTitle(mapView, layerTitle) {
        try {
            layerTitle = layerTitle.toLowerCase();
            let layerFound = null;
            mapView.map?.allLayers.map((layer) => {
                const layerTitleLower = layer.title ? layer.title.toLowerCase() : null;
                if (layerTitleLower === layerTitle) {
                    layerFound = layer;
                    return layerFound; // Return immediately if found  
                }
                if (layer.allSublayers) {
                    layer.allSublayers.map((sublayer) => {
                        const sublayerTitleLower = sublayer.title
                            ? sublayer.title.toLowerCase()
                            : null;
                        if (sublayerTitleLower === layerTitle) {
                            console.log('sublayer.title >> ', sublayerTitleLower);
                            layerFound = sublayer;
                            return layerFound;
                        }
                    });
                }
            });
            return layerFound;
        }
        catch (e) {
            console.error(e);
            return null;
        }
    }
    getUrlByLayerName(targetLayerName) {
        const layersConfig = this.configService?.config?.webapiConfig?.layersConfig;
        if (!layersConfig || !Array.isArray(layersConfig)) {
            console.error("mapLayers is undefined or not an array", this.configService?.config?.webapiConfig);
            return;
        }
        layersConfig.forEach((layer) => {
            console.log('layer.layerNameInMap', layer.layerNameInMap, 'targetLayerName', targetLayerName);
            if (layer.layerNameInMap === targetLayerName) {
                return layer.url;
            }
        });
        return null; // Return null if no match is found
    }
    // Method to highlight features where OBJECTID > 5
    async highlightFeatures(mapView, layerConfigName, queryToHighlight, type) {
        var highlightLayer;
        if (type == 'table') {
            const mapLayerUrl = this.getUrlByLayerName(layerConfigName);
            if (!mapLayerUrl) {
                console.error('No layer available to highlight features.');
                return false;
            }
            highlightLayer = new FeatureLayer({ url: mapLayerUrl });
        }
        else {
            highlightLayer = this.getLayerByTitle(mapView, layerConfigName);
        }
        if (!highlightLayer) {
            console.error('No layer available to highlight features.');
            return false;
        }
        if (highlightLayer.type !== 'feature') {
            console.error('Highlighting is only supported for FeatureLayers.');
            return false;
        }
        // Query the features based on the provided condition
        const query = highlightLayer.createQuery();
        query.where = queryToHighlight;
        try {
            const results = await highlightLayer.queryFeatures(query);
            const features = results.features;
            if (features.length === 0) {
                console.warn('No features found with the given query:', queryToHighlight);
                return false;
            }
            // Clear previous highlights
            mapView.graphics.removeAll();
            // Add the new highlights
            features.forEach((feature) => {
                const highlightSymbol = {
                    type: 'simple-fill',
                    color: [255, 255, 70, 0.5],
                    outline: {
                        color: [255, 255, 70],
                        width: 2,
                    },
                };
                const highlightGraphic = new Graphic({
                    geometry: feature.geometry,
                    symbol: highlightSymbol,
                });
                mapView.graphics.add(highlightGraphic);
            });
            // Zoom to the extent of the highlighted features
            const featureExtent = results.features[0].geometry?.extent;
            if (featureExtent) {
                await mapView.goTo(featureExtent.expand(1.5)); // Ensure goTo() is awaited
            }
            else {
                console.warn('No extent found for the highlighted features.');
            }
            return true;
        }
        catch (error) {
            console.error('Failed to highlight features:', error);
            return false;
        }
    }
    // Method to zoom to the full extent of a specified layer
    zoomToFullExtent(mapView, title) {
        var layer = this.getLayerByTitle(mapView, title);
        if (layer instanceof FeatureLayer) {
            layer
                .queryExtent()
                .then((result) => {
                if (result.extent) {
                    mapView.goTo(result.extent.expand(1.5)).catch((error) => {
                        //console.error('Failed to zoom to full extent of layer:', error);
                    });
                }
                else {
                    console.warn('No extent found for the specified layer.');
                }
            })
                .catch((error) => {
                //console.error('Error querying extent for layer:', error);
            });
            return true;
        }
        else {
            //console.error(`Layer with ID '${layerId}' is not a FeatureLayer.`);
            return false;
        }
    }
    // Method to change the transparency of a layer
    changeLayerOpacity(mapView, title, opacity) {
        const layer = this.getLayerByTitle(mapView, title);
        if (layer) {
            layer.opacity = parseFloat(opacity.toString());
        }
        else {
            //console.error(`Layer with ID '${layerId}' not found.`);
            return false;
        }
        return true;
    }
    printService = async (mapView) => {
        var printTaskUrl = this.configService.config.webapiConfig.printMapUrl;
        var layoutName = 'map-only';
        const template = new PrintTemplate({
            format: 'pdf',
            layout: layoutName,
            scalePreserved: false,
            layoutOptions: {
                copyrightText: '',
                customTextElements: [],
            },
        });
        const params = new PrintParameters({
            view: mapView,
            template: template,
        });
        console.log(params);
        let response = await print.execute(printTaskUrl, params);
        return this.generateHrefLink(response.url, 'Download Map Document', true);
    };
    generateHrefLink = (url, label, downloadable) => {
        const linkHtml = `<a target='_blank' href="${url}" ${downloadable ? 'download' : ''}>${label}</a>`;
        return linkHtml;
    };
    fromBaseToString = (bString) => {
        try {
            return atob(bString);
        }
        catch (error) {
            console.error(error);
            return "";
        }
    };
    getMapViewpoint = (mapView) => {
        try {
            return JSON.stringify(mapView?.viewpoint?.toJSON());
        }
        catch (error) {
            console.error(error);
            return "";
        }
    };
    generateMapViewerUrlFromCurrentLocation = (mapView) => {
        var centerPoint = mapView.extent.center;
        let pointLongLat = this.getPointLongLat(centerPoint);
        return `${window.location.origin}/map?lat=${pointLongLat.latitude}&long=${pointLongLat.longitude}&level=${mapView.zoom == -1 ? 15 : mapView.zoom}&shareMode=currentMapExtent&wkid=${mapView.spatialReference.wkid}`;
    };
    shareMap(mapView) {
        // Generate a shareable URL (modify this as needed)
        const shareUrl = this.generateMapViewerUrlFromCurrentLocation(mapView);
        // const fullUrl = `${window.location.origin}/map?extent=${extentParam}&center=${centerParam}&zoom=${zoomParam}`;
        const linkHtml = `<a href="${shareUrl}">Map URL</a>`;
        return linkHtml;
    }
    getPointLongLat = (point) => {
        try {
            return {
                latitude: point.latitude
                    ? point.latitude.toFixed(6)
                    : point.y.toFixed(6),
                longitude: point.longitude
                    ? point.longitude.toFixed(6)
                    : point.x.toFixed(6),
            };
        }
        catch (error) {
            console.error(error);
            return {
                latitude: null,
                longitude: null,
            };
        }
    };
    // Method to add a TimeSlider widget
    addTimeSlider(mapView, layerId) {
        const featureLayer = mapView.map.findLayerById(layerId);
        const timeSlider = new TimeSlider({
            container: 'timeSlider',
            mode: 'time-window',
            view: mapView,
        });
        mapView
            .whenLayerView(featureLayer)
            .then((lv) => {
            const timeInfo = featureLayer.timeInfo;
            // Check if timeInfo and interval are available
            if (timeInfo && timeInfo.interval) {
                timeSlider.stops = {
                    interval: timeInfo.interval,
                };
            }
            else {
                // Fallback to a default interval using TimeInterval
                const defaultInterval = new TimeInterval({
                    value: 1,
                    unit: 'days',
                });
                timeSlider.stops = {
                    interval: defaultInterval,
                };
            }
            // Set the full time extent, expanding to a specific unit if timeInfo exists
            if (timeInfo && timeInfo.fullTimeExtent) {
                // Expand the full time extent to the nearest hour and use the system's time zone
                timeSlider.fullTimeExtent = timeInfo.fullTimeExtent.expandTo('hours', 'system');
            }
            else {
                console.warn('Time extent information is not available.');
            }
        })
            .catch((error) => {
            //console.error("Error initializing time slider:", error);
        });
        mapView.ui.add(timeSlider, 'bottom-left');
    }
    goToMapFullExtent = (mapView) => {
        mapView.extent = this.initialExtent;
    };
    zoomToLocation = (mapView, locationName) => {
        this.getLatLongForPlace(locationName).then((result) => {
            if (result) {
                console.log(`Latitude: ${result.latitude}, Longitude: ${result.longitude}`);
                mapView.goTo({ target: [result.longitude, result.latitude] });
            }
            else {
                console.log("No coordinates found for the place.");
            }
        });
        console.log('inside zoom to function ' + locationName);
    };
    async getLatLongForPlace(placeName) {
        try {
            // Call the ArcGIS Geocode Service
            const results = await Locator.addressToLocations(this.configService.config.webapiConfig.geoCodeUrl, {
                address: { SingleLine: placeName },
                maxLocations: 1
            });
            if (results && results.length > 0) {
                const location = results[0].location;
                return {
                    latitude: location.y,
                    longitude: location.x,
                };
            }
            // If no results found
            console.error("No results found for the given place name.");
            return null;
        }
        catch (error) {
            console.error("Error using the Geocode Service:", error);
            return null;
        }
    }
    reorderLayer(mapView, layerTitle, index) {
        // Find the layer by its ID
        const layer = this.getLayerByTitle(mapView, layerTitle); //this.map.findLayerById(layerId);
        if (layer) {
            // Reorder the layer to the desired index
            console.log('before', mapView.map.allLayers);
            mapView.map.reorder(layer, parseInt(index.toString()));
            console.log(mapView.map.allLayers);
            // console.log(`Layer ${layerId} moved to index ${index}.`);
        }
        else {
            // console.error(`Layer with ID ${layerId} not found.`);
        }
    }
    queryLayer(mapView, layerTitle, queryText) {
        // Find the layer by its ID
        const layer = this.getLayerByTitle(mapView, layerTitle); //this.map.findLayerById(layerId) as FeatureLayer;
        if (layer) {
            layer.definitionExpression = queryText;
        }
    }
    clearHighlightedFeatures = (mapView) => {
        if (mapView && mapView.graphics) {
            // Clear previous highlights
            console.log('this.mapView.graphics before', mapView.graphics.length);
            mapView.graphics.removeAll();
            console.log('this.mapView.graphics after', mapView.graphics.length);
        }
    };
    getMapViewInfo = (mapView) => {
        const mapConfig = {
            extent: mapView.extent
                ? {
                    xmin: mapView.extent.xmin,
                    ymin: mapView.extent.ymin,
                    xmax: mapView.extent.xmax,
                    ymax: mapView.extent.ymax,
                    spatialReference: {
                        wkid: mapView.extent.spatialReference.wkid,
                    },
                }
                : null,
            mapLayersInfo: this.getMapLayersInfo(mapView),
        };
        return mapConfig;
    };
    getMapLayersInfo(mapView) {
        try {
            let layersInfo = [];
            mapView.map.allLayers.forEach((layer) => {
                let layerInfo = {
                    title: layer.title,
                    url: layer.url,
                    opacity: layer.opacity,
                    visible: layer.visible,
                    definitionQuery: layer.definitionExpression || null,
                    sublayers: [],
                };
                if (layer.allSublayers) {
                    layer.allSublayers.forEach((sublayer) => {
                        let sublayerInfo = {
                            title: sublayer.title,
                            id: sublayer.id,
                            url: sublayer.url,
                            opacity: sublayer.opacity,
                            visible: sublayer.visible,
                            definitionQuery: sublayer.definitionExpression || null,
                        };
                        layerInfo.sublayers.push(sublayerInfo);
                    });
                }
                layersInfo.push(layerInfo);
            });
            return layersInfo;
        }
        catch (e) {
            console.error(e);
            return null;
        }
    }
    setExpandWidgetsToggleListener = () => {
        try {
            this.eventsService.openedExpandWidgetNameEventSubject.subscribe((expandWidgetName) => {
                this.mapExpandsWidget.map((expandWidget) => {
                    if (expandWidget?.id?.toLowerCase() != expandWidgetName.toLowerCase()) {
                        expandWidget.collapse();
                    }
                });
            });
        }
        catch (error) {
            console.error(error);
        }
    };
    initalizeBookmark = (mapView) => {
        // Create the bookmarks widget
        this.bookmarks = new Bookmarks({
            view: mapView,
            dragEnabled: true,
            visibleElements: {
                addBookmarkButton: false,
                editBookmarkButton: false,
                time: false, // don't show the time (h:m:s) next to the date
            },
        });
        // Create an Expand widget to show/hide the bookmarks
        const bkExpand = new Expand({
            view: mapView,
            content: this.bookmarks,
        });
        // Add the widget to the top-left corner of the view
        mapView.ui.add(bkExpand, 'top-left');
        this.loadBookmarks();
    };
    // Method to save a bookmark with a given name
    addBookmark(mapView, bookmarkName) {
        // Ensure the mapView is loaded before accessing its properties
        mapView.when(() => {
            // Get the current extent of the map
            const currentExtent = mapView.extent;
            if (!currentExtent) {
                console.error('Map extent is undefined, cannot save the bookmark.');
                return;
            }
            const newBookmark = new Bookmark({
                name: bookmarkName,
                viewpoint: {
                    targetGeometry: currentExtent,
                },
            });
            // Check if the bookmark already exists
            const existingBookmark = this.bookmarks.bookmarks.find((bookmark) => bookmark.name.toLowerCase() === bookmarkName.toLowerCase());
            if (existingBookmark) {
                console.warn(`Bookmark "${bookmarkName}" already exists. Skipping addition.`);
                return; // Optionally, return or notify the user
            }
            console.log('newBookmark', newBookmark);
            // Add the new bookmark to the bookmarks collection
            this.bookmarks.bookmarks.add(newBookmark);
            console.log('this.bookmarks.bookmarks', this.bookmarks.bookmarks);
            console.log('JSON.stringify(this.bookmarks.bookmarks)', JSON.stringify(this.bookmarks.bookmarks));
            // Save bookmarks to localStorage
            localStorage.setItem('bookmarks', JSON.stringify(this.bookmarks.bookmarks));
            // Log all bookmarks
            this.bookmarks.bookmarks.forEach((bookmark) => {
                console.log('bookmark', bookmark);
            });
        });
    }
    loadBookmarkByName(mapView, name) {
        // Find the bookmark by name
        const bookmark = this.bookmarks.bookmarks.find((b) => b.name === name);
        if (bookmark) {
            // Log the bookmark information
            console.log(`Loading bookmark: ${bookmark.name}`);
            // Assuming you have a mapView or equivalent object, you can set the map view
            // For example, with a MapView object from a library like ArcGIS:
            mapView.goTo(bookmark.viewpoint);
        }
        else {
            console.log(`Bookmark with name "${name}" not found.`);
        }
    }
    loadBookmarks() {
        const storedBookmarks = localStorage.getItem('bookmarks');
        if (storedBookmarks) {
            const bookmarkArray = JSON.parse(storedBookmarks);
            // Clear existing bookmarks if needed
            this.bookmarks.bookmarks.removeAll();
            // Add the bookmarks from localStorage back into the widget
            bookmarkArray.forEach((bookmark) => {
                const newBookmark = new Bookmark({
                    name: bookmark.name,
                    viewpoint: {
                        targetGeometry: new Extent({
                            xmin: bookmark.extent.xmin,
                            ymin: bookmark.extent.ymin,
                            xmax: bookmark.extent.xmax,
                            ymax: bookmark.extent.ymax,
                            spatialReference: {
                                wkid: bookmark.extent.spatialReference.wkid,
                            },
                        }),
                    },
                });
                this.bookmarks.bookmarks.add(newBookmark);
            });
            console.log('Bookmarks loaded from localStorage:', bookmarkArray);
        }
        else {
            console.log('No bookmarks found in localStorage.');
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ArcgisService, deps: [{ token: ConfigService }, { token: EventsService }, { token: IdentityService }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ArcgisService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ArcgisService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: ConfigService }, { type: EventsService }, { type: IdentityService }] });

class MapComponent {
    configService;
    arcgisService;
    mapViewEl;
    constructor(configService, arcgisService) {
        this.configService = configService;
        this.arcgisService = arcgisService;
    }
    async ngOnInit() {
        const webmapId = this.configService.config.webapiConfig.mapConfig.webmapId;
        let mapView = await this.arcgisService.initializeMap(this.configService.config.appConfig, webmapId, this.mapViewEl);
        mapView.when(async () => {
            this.configService.config.mapView = mapView;
            this.arcgisService.addWidgetsOnScreen(this.configService.config, mapView);
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MapComponent, deps: [{ token: ConfigService }, { token: ArcgisService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.4", type: MapComponent, isStandalone: false, selector: "app-map", viewQueries: [{ propertyName: "mapViewEl", first: true, predicate: ["mapViewNode"], descendants: true, static: true }], ngImport: i0, template: "\r\n<h1 mat-dialog-title cdkDrag cdkDragRootElement=\".cdk-overlay-pane\" cdkDragHandle\r\n cdkFocusInitial><mat-icon mat-dialog-close matTooltip=\"Close Map\">close</mat-icon>\r\n </h1>\r\n  <!-- Your map content here -->\r\n  <div class=\"map__container\">\r\n    <div class=\"map-view__container\">\r\n      <div class=\"map\" #mapViewNode ></div>\r\n    </div>\r\n</div>\r\n\r\n", styles: [".map__container{height:100%;width:100%}[mat-dialog-title]{color:#fff;cursor:move;display:flex;align-items:center;justify-content:end}[mat-dialog-close]{color:#fff;cursor:pointer;float:right}\n"], dependencies: [{ kind: "directive", type: i3.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer", "cdkDragScale"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "directive", type: i3.CdkDragHandle, selector: "[cdkDragHandle]", inputs: ["cdkDragHandleDisabled"] }, { kind: "directive", type: i3$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i3$1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i6.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MapComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-map', standalone: false, template: "\r\n<h1 mat-dialog-title cdkDrag cdkDragRootElement=\".cdk-overlay-pane\" cdkDragHandle\r\n cdkFocusInitial><mat-icon mat-dialog-close matTooltip=\"Close Map\">close</mat-icon>\r\n </h1>\r\n  <!-- Your map content here -->\r\n  <div class=\"map__container\">\r\n    <div class=\"map-view__container\">\r\n      <div class=\"map\" #mapViewNode ></div>\r\n    </div>\r\n</div>\r\n\r\n", styles: [".map__container{height:100%;width:100%}[mat-dialog-title]{color:#fff;cursor:move;display:flex;align-items:center;justify-content:end}[mat-dialog-close]{color:#fff;cursor:pointer;float:right}\n"] }]
        }], ctorParameters: () => [{ type: ConfigService }, { type: ArcgisService }], propDecorators: { mapViewEl: [{
                type: ViewChild,
                args: ['mapViewNode', { static: true }]
            }] } });

class Alert {
    Message = "";
    Type = "";
    ConfirmLabel = "";
    RejectLabel = "";
    promptResult = "";
    constructor(message, type, confirmLabel, rejectLabel) {
        this.Message = message;
        this.Type = type;
        this.ConfirmLabel = confirmLabel;
        this.RejectLabel = rejectLabel;
    }
}

class AlertComponent {
    data;
    configService;
    config;
    constructor(data, configService) {
        this.data = data;
        this.configService = configService;
        this.config = configService.config;
    }
    ngOnInit() {
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: AlertComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: ConfigService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.4", type: AlertComponent, isStandalone: false, selector: "app-alert", ngImport: i0, template: "<div mat-dialog-content *ngIf=\"data.Type!=='waiting'\">\r\n    <div class=\"row\">\r\n        <div class=\"col-12\" *ngIf=\"data.Type!='confirmation'\">\r\n            <img *ngIf=\"data.Type=='error'\" src=\"assets/icons/error.svg\">\r\n            <img *ngIf=\"data.Type=='success'\" src=\"assets/icons/check.svg\">\r\n        </div>\r\n        <div class=\"col-12\">\r\n            <label>{{data.Message}}</label>\r\n        </div>\r\n    </div>\r\n    <div *ngIf=\"data.Type=='prompt'\">\r\n        <mat-form-field appearance=\"outline\">\r\n            <mat-label>Alert</mat-label>\r\n            <input color=\"primary\" matInput [(ngModel)]=\"data.promptResult\">\r\n        </mat-form-field>\r\n    </div>\r\n</div>\r\n<div mat-dialog-actions *ngIf=\"data.Type!=='waiting'\">\r\n    <button *ngIf=\"data.Type==='confirmation' || data.Type==='prompt'\" mat-button \r\n        class=\"btn btn-reject\">\r\n        {{ data.RejectLabel }}\r\n    </button>\r\n    <button *ngIf=\"data.Type !== 'prompt'\" mat-button mat-dialog-close class=\"btn btn-confirm\" cdkFocusInitial>\r\n        {{ data.ConfirmLabel }}\r\n    </button>\r\n    <button *ngIf=\"data.Type === 'prompt'\" mat-button  mat-dialog-close class=\"btn btn-confirm\"\r\n        cdkFocusInitial>\r\n        {{ data.ConfirmLabel }}\r\n    </button>\r\n</div>\r\n<div mat-dialog-content *ngIf=\"data.Type==='waiting'\" class=\"alert-dialog-waiting\">\r\n    <mat-spinner></mat-spinner>\r\n</div>", styles: [":host ::ng-deep .mat-dialog-content{font-family:CorporateSBold;font-weight:700;color:#4c5e69;text-align:left}:host ::ng-deep .mat-dialog-content img{width:5rem}:host ::ng-deep .mat-dialog-actions{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:end}:host ::ng-deep .mat-dialog-actions .btn{border-radius:10px;color:#fff}:host ::ng-deep .mat-dialog-actions .btn-confirm{background-color:#e6b27d}:host ::ng-deep .mat-dialog-actions .btn-reject{background-color:#7d9aaa}\n"], dependencies: [{ kind: "component", type: i5$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "directive", type: i3$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i3$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i3$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i5$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i5$2.MatLabel, selector: "mat-label" }, { kind: "component", type: i6$1.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "directive", type: i7.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i7.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i7.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i9.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: AlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-alert', standalone: false, template: "<div mat-dialog-content *ngIf=\"data.Type!=='waiting'\">\r\n    <div class=\"row\">\r\n        <div class=\"col-12\" *ngIf=\"data.Type!='confirmation'\">\r\n            <img *ngIf=\"data.Type=='error'\" src=\"assets/icons/error.svg\">\r\n            <img *ngIf=\"data.Type=='success'\" src=\"assets/icons/check.svg\">\r\n        </div>\r\n        <div class=\"col-12\">\r\n            <label>{{data.Message}}</label>\r\n        </div>\r\n    </div>\r\n    <div *ngIf=\"data.Type=='prompt'\">\r\n        <mat-form-field appearance=\"outline\">\r\n            <mat-label>Alert</mat-label>\r\n            <input color=\"primary\" matInput [(ngModel)]=\"data.promptResult\">\r\n        </mat-form-field>\r\n    </div>\r\n</div>\r\n<div mat-dialog-actions *ngIf=\"data.Type!=='waiting'\">\r\n    <button *ngIf=\"data.Type==='confirmation' || data.Type==='prompt'\" mat-button \r\n        class=\"btn btn-reject\">\r\n        {{ data.RejectLabel }}\r\n    </button>\r\n    <button *ngIf=\"data.Type !== 'prompt'\" mat-button mat-dialog-close class=\"btn btn-confirm\" cdkFocusInitial>\r\n        {{ data.ConfirmLabel }}\r\n    </button>\r\n    <button *ngIf=\"data.Type === 'prompt'\" mat-button  mat-dialog-close class=\"btn btn-confirm\"\r\n        cdkFocusInitial>\r\n        {{ data.ConfirmLabel }}\r\n    </button>\r\n</div>\r\n<div mat-dialog-content *ngIf=\"data.Type==='waiting'\" class=\"alert-dialog-waiting\">\r\n    <mat-spinner></mat-spinner>\r\n</div>", styles: [":host ::ng-deep .mat-dialog-content{font-family:CorporateSBold;font-weight:700;color:#4c5e69;text-align:left}:host ::ng-deep .mat-dialog-content img{width:5rem}:host ::ng-deep .mat-dialog-actions{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:end}:host ::ng-deep .mat-dialog-actions .btn{border-radius:10px;color:#fff}:host ::ng-deep .mat-dialog-actions .btn-confirm{background-color:#e6b27d}:host ::ng-deep .mat-dialog-actions .btn-reject{background-color:#7d9aaa}\n"] }]
        }], ctorParameters: () => [{ type: Alert, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: ConfigService }] });

class ChartHelper {
    platformId;
    configService;
    http;
    arcgisService;
    zone;
    eventsService;
    config;
    targetLayerConfig;
    graphicLayer = new GraphicsLayer();
    constructor(platformId, configService, http, arcgisService, zone, eventsService) {
        this.platformId = platformId;
        this.configService = configService;
        this.http = http;
        this.arcgisService = arcgisService;
        this.zone = zone;
        this.eventsService = eventsService;
        this.config = this.configService.config;
    }
    browserOnly(f) {
        if (isPlatformBrowser(this.platformId)) {
            this.zone.runOutsideAngular(() => {
                f();
            });
        }
    }
    barChartGeneration = (chartId, chartData, xAxsisLabel, yAxsisLabel, allowChartZooming = true, colorEachColunm = false) => {
        let mainChartID = chartId;
        chartId = chartId.replace("_print", "");
        let root = am5.Root.new(mainChartID);
        console.log('chartData', chartData);
        try {
            this.browserOnly(async () => {
                const customResponsive = am5themes_Responsive.new(root);
                root.setThemes([
                    am5themes_Animated.new(root),
                    // am5themes_Responsive.new(root)// default responsive theme
                    customResponsive //custom responsive theme
                ]);
                let chart = root.container.children.push(am5xy.XYChart.new(root, {
                    // to allow zooming on the chart
                    panX: allowChartZooming,
                    panY: allowChartZooming,
                    wheelX: allowChartZooming ? "panX" : "none",
                    wheelY: allowChartZooming ? "zoomX" : "none"
                }));
                let easing = am5.ease.linear;
                //#region y axis
                let yAxis = chart.yAxes.push(am5xy.ValueAxis.new(root, {
                    renderer: am5xy.AxisRendererY.new(root, {})
                }));
                var yRenderer = yAxis.get("renderer");
                // colunm labels
                yRenderer.labels.template.setAll({
                    fontFamily: "tahoma",
                    fontSize: 11,
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255),
                    fill: colorEachColunm ?
                        am5.Color.fromRGB(193, 196, 198) :
                        (chartId.indexOf("electricity") >= 0) ?
                            am5.Color.fromRGB(230, 178, 125) :
                            am5.Color.fromRGB(92, 174, 215)
                });
                //y axis title
                var yAxisTitle = am5.Label.new(root, {
                    rotation: -90,
                    text: yAxsisLabel,
                    y: am5.percent(50),
                    centerX: am5.percent(50),
                    fontFamily: "CorporateSRegular",
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255)
                    fill: colorEachColunm ?
                        am5.Color.fromRGB(193, 196, 198) :
                        (chartId.indexOf("electricity") >= 0) ?
                            am5.Color.fromRGB(230, 178, 125) :
                            am5.Color.fromRGB(92, 174, 215)
                });
                yAxis.children.unshift(yAxisTitle);
                //#endregion
                //#region x axis
                let xAxis = chart.xAxes.push(am5xy.CategoryAxis.new(root, {
                    renderer: am5xy.AxisRendererX.new(root, {
                        minGridDistance: 1, // space between column
                    }),
                    categoryField: "key",
                    // tooltip: am5.Tooltip.new(root, {}),
                }));
                xAxis.data.setAll(chartData);
                // x-axis column labels
                var xRenderer = xAxis.get("renderer");
                xRenderer.labels.template.setAll({
                    // rotate xaxis labels
                    rotation: -45,
                    centerY: am5.p0,
                    centerX: am5.p100,
                    paddingRight: 15,
                    // no rotation
                    // centerY: am5.percent(0),
                    //
                    y: am5.percent(0),
                    paddingTop: 0,
                    paddingBottom: 0,
                    fontFamily: "tahoma",
                    fontSize: 11,
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255),
                    fill: colorEachColunm ?
                        am5.Color.fromRGB(193, 196, 198) :
                        (chartId.indexOf("electricity") >= 0) ?
                            am5.Color.fromRGB(230, 178, 125) :
                            am5.Color.fromRGB(92, 174, 215)
                });
                // rotate xaxis labels
                xRenderer.grid.template.setAll({
                    location: 1
                });
                // x axis title
                xAxis.children.unshift(am5.Label.new(root, {
                    rotation: 0,
                    text: xAxsisLabel,
                    centerY: am5.percent(230),
                    y: am5.percent(230),
                    // centerX: am5.percent(0),
                    // x: am5.percent(85),
                    centerX: am5.percent(50),
                    x: am5.percent(50),
                    paddingTop: 0,
                    paddingBottom: 0,
                    height: 17,
                    // id: `${chartId}-x-axis-title`,
                    id: `${mainChartID}-x-axis-title`,
                    fontFamily: "CorporateSRegular",
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255),
                    fill: colorEachColunm ?
                        am5.Color.fromRGB(193, 196, 198) :
                        (chartId.indexOf("electricity") >= 0) ?
                            am5.Color.fromRGB(230, 178, 125) :
                            am5.Color.fromRGB(92, 174, 215)
                }));
                //#endregion
                //#region  series
                let series = chart.series.push(am5xy.ColumnSeries.new(root, {
                    name: "Series",
                    xAxis: xAxis,
                    yAxis: yAxis,
                    valueYField: "value",
                    categoryXField: "key",
                    paddingBottom: 0,
                    marginBottom: 0,
                    // column animation on loading
                    // one by one animation
                    // sequencedInterpolation: true,
                    // sequencedDelay: 100,
                    stateAnimationDuration: 10000,
                    stateAnimationEasing: am5.ease.out(am5.ease.linear),
                    // stroke: am5.color(0x657d8b00),
                    tooltip: am5.Tooltip.new(root, {
                        labelText: "{valueY}",
                    })
                }));
                //set active column properties
                series.columns.template.states.create("active", {
                    strokeOpacity: 1,
                    strokeWidth: 3
                });
                // column corner radius
                series.columns.template.setAll({
                    cornerRadiusTL: 3,
                    cornerRadiusTR: 3,
                    maxWidth: 40,
                    strokeOpacity: 0
                });
                series.data.setAll(chartData);
                root.numberFormatter.setAll({
                    numberFormat: "#.00 a",
                    bigNumberPrefixes: [
                        { number: 1e+3, suffix: " K" },
                        { number: 1e+6, suffix: " M" },
                        { number: 1e+9, suffix: " B" },
                        { number: 1e+12, suffix: " T" },
                        { number: 1e+15, suffix: " Qa" },
                        { number: 1e+18, suffix: " Qi" },
                        { number: 1e+21, suffix: " Sx" },
                    ],
                });
                // column values on top of the bar
                // series.bullets.push(() => {
                //     return am5.Bullet.new(root, {
                //         locationY: 1,
                //         sprite: am5.Label.new(root, {
                //             text: "{value}",
                //             fill: am5.Color.fromRGB(255, 255, 255),
                //             centerY: am5.percent(100),
                //             centerX: am5.percent(50),
                //             fontSize: 11,
                //             populateText: true,
                //             paddingBottom: 2,
                //             marginBottom: 2,
                //         })
                //     });
                // });
                //#endregion
                // add cursor
                chart.set("cursor", am5xy.XYCursor.new(root, {}));
                // remove amcharts watermark
                root._logo?.dispose();
                // series.data.setAll(chartData);
                // let legend = chart.children.push(am5.Legend.new(root, {}));
                // legend.data.setAll(chart.series.values);
                // change column color based on the chart electricity or water
                var columnTemplate = series.columns.template;
                if (colorEachColunm) {
                    columnTemplate.adapters.add("fill", (fill, target) => {
                        return chart?.get("colors")?.getIndex(series.columns.indexOf(target));
                    });
                    columnTemplate.adapters.add("stroke", (stroke, target) => {
                        return chart?.get("colors")?.getIndex(series.columns.indexOf(target));
                    });
                }
                // listen if charts data are changed
                this.eventsService.reportsChartsDataEvent.subscribe((updatedData) => {
                    if (updatedData &&
                        updatedData.length > 0 &&
                        updatedData[0].additionalProperties.chartId == mainChartID &&
                        updatedData[0].additionalProperties.action == "reset") {
                        series.data.setAll([]);
                        xAxis.data.setAll([]);
                    }
                    else {
                        if (updatedData && updatedData.length > 0 && updatedData[0].additionalProperties.chartId == mainChartID) {
                            series.data.setAll(updatedData);
                            // repeat series animation
                            // series.appear();
                            // onclick on chart column highlight other
                            series.columns.template.events.on("click", async (event) => {
                                let featureInfo = event.target.dataItem.dataContext;
                                this.eventsService.selectedChartColumn({
                                    chartId: chartId,
                                    columnKey: featureInfo?.key
                                });
                            });
                            this.eventsService.selectedChartColumnDataEvent.subscribe((selectedColumn) => {
                                // check if the same pair charts
                                if (selectedColumn &&
                                    selectedColumn.chartId.replace("-electricity-", "-").replace("-water-", "-")
                                        ==
                                            chartId.replace("-electricity-", "-").replace("-water-", "-")) {
                                    // highlight clicked colunm
                                    chart.series.each((series) => {
                                        if (series instanceof am5xy.ColumnSeries) {
                                            let selectedColumnIndex = xAxis.categoryToIndex(selectedColumn.columnKey);
                                            // highlight column
                                            this.highlightBarChartReportColumn(chartId, series, selectedColumn.columnKey);
                                            if (!(selectedColumnIndex == undefined || selectedColumnIndex == null || isNaN(selectedColumnIndex))) {
                                                // zoom to column
                                                xAxis.zoomToIndexes(xAxis.categoryToIndex(selectedColumn.columnKey) - 2, xAxis.categoryToIndex(selectedColumn.columnKey) + 2, 1000);
                                            }
                                        }
                                    });
                                }
                            });
                            xAxis.data.setAll(updatedData);
                            // // exporting
                            // am5plugins_exporting.Exporting.new(root, {
                            //     menu: am5plugins_exporting.ExportingMenu.new(root, {}),
                            //     // some options are will not be available
                            //     // even if they are enabled according to the data for e.g. json option
                            //     // cant be showin if the data is numericFields
                            //     pngOptions: { disabled: false, quality: 1 },
                            //     jpgOptions: { disabled: false, quality: 1 },
                            //     pdfOptions: { disabled: false, quality: 1 },
                            //     pdfdataOptions: { disabled: false, addColumnNames: true },
                            //     xlsxOptions: { disabled: false, addColumnNames: true },
                            //     csvOptions: { disabled: false, addColumnNames: true, addBOM: true },
                            //     printOptions: { disabled: false, quality: 1, delay: 500 },
                            //     jsonOptions: { disabled: true, addColumnNames: true },
                            //     htmlOptions: { disabled: true },
                            //     dataSource: chartData,
                            //     numericFields: ["value"],
                            //     numberFormat: "#,###",
                            //     // dataFields is an object which identifies which columns to export (object key) 
                            //     // and how to name their column (value).
                            //     dataFields: {
                            //         key: xAxsisLabel,
                            //         value: yAxsisLabel
                            //     },
                            //     dataFieldsOrder: ["key", "value"],
                            // });
                            // chart bar color
                            // this.fillColorsPalettes();
                        }
                    }
                });
            });
        }
        catch (error) {
            console.error("generateAmChart error ", error);
        }
        return root;
    };
    highlightBarChartReportColumn = (chartId, series, clickedFeatureKey) => {
        try {
            series.columns.each((column) => {
                let isActive = (column?.dataItem?.dataContext?.key ?? null) == clickedFeatureKey;
                column.set("active", isActive);
                column.adapters.add("stroke", (stroke, target) => {
                    let barColumnStroke = chartId.indexOf("water") >= 0 ? "#5c6bc0" : "#f57c00";
                    return isActive ? am5.Color.fromRGB(255, 255, 255) : barColumnStroke == "" ? stroke : am5.color(barColumnStroke);
                });
            });
        }
        catch (error) {
            console.error(error);
        }
    };
    lineChartGeneration = (chartId, chartData, xAxsisLabel, yAxsisLabel, allowChartZooming = true) => {
        let mainChartID = chartId;
        chartId = chartId.replace("_print", "");
        let root = am5.Root.new(mainChartID);
        console.log('chartData', chartData);
        try {
            this.browserOnly(async () => {
                const customResponsive = am5themes_Responsive.new(root);
                root.setThemes([
                    am5themes_Animated.new(root),
                    // am5themes_Responsive.new(root)// default responsive theme
                    customResponsive //custom responsive theme
                ]);
                let chart = root.container.children.push(am5xy.XYChart.new(root, {
                    // to allow zooming on the chart
                    panX: allowChartZooming,
                    panY: allowChartZooming,
                    wheelX: allowChartZooming ? "panX" : "none",
                    wheelY: allowChartZooming ? "zoomX" : "none"
                }));
                let easing = am5.ease.linear;
                //#region y axis
                let yAxis = chart.yAxes.push(am5xy.ValueAxis.new(root, {
                    renderer: am5xy.AxisRendererY.new(root, {})
                }));
                var yRenderer = yAxis.get("renderer");
                // colunm labels
                yRenderer.labels.template.setAll({
                    fontFamily: "tahoma",
                    fontSize: 11,
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255),
                    fill: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215)
                });
                //y axis title
                var yAxisTitle = am5.Label.new(root, {
                    rotation: -90,
                    text: yAxsisLabel,
                    y: am5.percent(50),
                    centerX: am5.percent(50),
                    fontFamily: "CorporateSRegular",
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255)
                    fill: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215)
                });
                yAxis.children.unshift(yAxisTitle);
                //#endregion
                //#region x axis
                let xAxis = chart.xAxes.push(am5xy.CategoryAxis.new(root, {
                    renderer: am5xy.AxisRendererX.new(root, {
                        minGridDistance: 1, // space between column
                    }),
                    categoryField: "key",
                    // tooltip: am5.Tooltip.new(root, {}),
                }));
                xAxis.data.setAll(chartData);
                // x-axis column labels
                var xRenderer = xAxis.get("renderer");
                xRenderer.labels.template.setAll({
                    // rotate xaxis labels
                    // rotation: -45,
                    // centerY: am5.p0,
                    // centerX: am5.p100,
                    // paddingRight: 15,
                    // no rotation
                    centerY: am5.percent(0),
                    //
                    y: am5.percent(0),
                    paddingTop: 0,
                    paddingBottom: 0,
                    fontFamily: "tahoma",
                    fontSize: 11,
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255),
                    fill: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215)
                });
                // rotate xaxis labels
                xRenderer.grid.template.setAll({
                    location: 1
                });
                // x axis title
                xAxis.children.unshift(am5.Label.new(root, {
                    rotation: 0,
                    text: xAxsisLabel,
                    centerY: am5.percent(230),
                    y: am5.percent(230),
                    // centerX: am5.percent(0),
                    // x: am5.percent(85),
                    centerX: am5.percent(50),
                    x: am5.percent(50),
                    paddingTop: 0,
                    paddingBottom: 0,
                    height: 17,
                    // id: `${chartId}-x-axis-title`,
                    id: `${mainChartID}-x-axis-title`,
                    fontFamily: "CorporateSRegular",
                    // fill: isPrintMode ? am5.Color.fromRGB(0, 0, 0) : am5.Color.fromRGB(255, 255, 255),
                    fill: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215)
                }));
                //#endregion
                //#region  series
                let series = chart.series.push(am5xy.LineSeries.new(root, {
                    name: "Series",
                    xAxis: xAxis,
                    yAxis: yAxis,
                    valueYField: "value",
                    categoryXField: "key",
                    paddingBottom: 0,
                    marginBottom: 0,
                    // column animation on loading
                    // one by one animation
                    // sequencedInterpolation: true,
                    // sequencedDelay: 100,
                    stateAnimationDuration: 10000,
                    stateAnimationEasing: am5.ease.out(am5.ease.linear),
                    width: 3,
                    fill: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215),
                    stroke: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215)
                }));
                // series.bullets.push(() => {
                //     let bulletCircle = am5.Circle.new(root, {
                //         radius: 5,
                //         fill: (chartId.indexOf("electricity") >= 0) ?
                //             am5.Color.fromRGB(230, 178, 125) :
                //             am5.Color.fromRGB(92, 174, 215)
                //     });
                //     return am5.Bullet.new(root, {
                //         sprite: bulletCircle
                //     })
                // });
                let bulletTemplate = am5.Template.new({});
                series.bullets.push(function (root) {
                    return am5.Bullet.new(root, {
                        sprite: am5.Circle.new(root, {
                            radius: 10,
                            fill: (chartId.indexOf("electricity") >= 0) ?
                                am5.Color.fromRGB(230, 178, 125) :
                                am5.Color.fromRGB(92, 174, 215)
                        }, bulletTemplate)
                    });
                });
                let seriesTooltip = am5.Tooltip.new(root, {
                    labelText: "{valueY}",
                });
                seriesTooltip.get("background").setAll({
                    fill: (chartId.indexOf("electricity") >= 0) ?
                        am5.Color.fromRGB(230, 178, 125) :
                        am5.Color.fromRGB(92, 174, 215)
                });
                series.set("tooltip", seriesTooltip);
                series.data.setAll(chartData);
                xAxis.data.setAll(chartData);
                root.numberFormatter.setAll({
                    numberFormat: "#.00 a",
                    bigNumberPrefixes: [
                        { number: 1e+3, suffix: " K" },
                        { number: 1e+6, suffix: " M" },
                        { number: 1e+9, suffix: " B" },
                        { number: 1e+12, suffix: " T" },
                        { number: 1e+15, suffix: " Qa" },
                        { number: 1e+18, suffix: " Qi" },
                        { number: 1e+21, suffix: " Sx" },
                    ],
                });
                // column values on top of the bar
                // series.bullets.push(() => {
                //     return am5.Bullet.new(root, {
                //         locationY: 1,
                //         sprite: am5.Label.new(root, {
                //             text: "{value}",
                //             fill: am5.Color.fromRGB(255, 255, 255),
                //             centerY: am5.percent(100),
                //             centerX: am5.percent(50),
                //             fontSize: 11,
                //             populateText: true,
                //             paddingBottom: 2,
                //             marginBottom: 2,
                //         })
                //     });
                // });
                //#endregion
                // add cursor
                chart.set("cursor", am5xy.XYCursor.new(root, {}));
                // remove amcharts watermark
                root._logo?.dispose();
                // series.data.setAll(chartData);
                // let legend = chart.children.push(am5.Legend.new(root, {}));
                // legend.data.setAll(chart.series.values);
                // listen if charts data are changed
                this.eventsService.reportsChartsDataEvent.subscribe((updatedData) => {
                    if (updatedData &&
                        updatedData.length > 0 &&
                        updatedData[0].additionalProperties.chartId == mainChartID &&
                        updatedData[0].additionalProperties.action == "reset") {
                        series.data.setAll([]);
                        xAxis.data.setAll([]);
                    }
                    else {
                        if (updatedData && updatedData.length > 0 && updatedData[0].additionalProperties.chartId == mainChartID) {
                            series.data.setAll(updatedData);
                            xAxis.data.setAll(updatedData);
                            // onclick on chart column highlight other
                            bulletTemplate.events.on("click", (event) => {
                                let featureInfo = event.target.dataItem.dataContext;
                                this.eventsService.selectedChartColumn({
                                    chartId: chartId,
                                    columnKey: featureInfo?.key
                                });
                            });
                            // // exporting
                            // am5plugins_exporting.Exporting.new(root, {
                            //     menu: am5plugins_exporting.ExportingMenu.new(root, {}),
                            //     // some options are will not be available
                            //     // even if they are enabled according to the data for e.g. json option
                            //     // cant be showin if the data is numericFields
                            //     pngOptions: { disabled: false, quality: 1 },
                            //     jpgOptions: { disabled: false, quality: 1 },
                            //     pdfOptions: { disabled: false, quality: 1 },
                            //     pdfdataOptions: { disabled: false, addColumnNames: true },
                            //     xlsxOptions: { disabled: false, addColumnNames: true },
                            //     csvOptions: { disabled: false, addColumnNames: true, addBOM: true },
                            //     printOptions: { disabled: false, quality: 1, delay: 500 },
                            //     jsonOptions: { disabled: true, addColumnNames: true },
                            //     htmlOptions: { disabled: true },
                            //     dataSource: chartData,
                            //     numericFields: ["value"],
                            //     numberFormat: "#,###",
                            //     // dataFields is an object which identifies which columns to export (object key) 
                            //     // and how to name their column (value).
                            //     dataFields: {
                            //         key: xAxsisLabel,
                            //         value: yAxsisLabel
                            //     },
                            //     dataFieldsOrder: ["key", "value"],
                            // });
                            // chart bar color
                            // this.fillColorsPalettes();
                        }
                    }
                });
            });
        }
        catch (error) {
            console.error("generateAmChart error ", error);
        }
        return root;
    };
    pieChartGeneration = (chartId, chartData, xAxsisLabel, yAxsisLabel, allowChartZooming = true, semiPieChart = false) => {
        let mainChartID = chartId;
        chartId = chartId.replace("_print", "");
        let root = am5.Root.new(mainChartID);
        try {
            this.browserOnly(async () => {
                const customResponsive = am5themes_Responsive.new(root);
                console.log('chartData', chartData);
                root.setThemes([
                    am5themes_Animated.new(root),
                    customResponsive //custom responsive theme
                ]);
                let chart = root.container.children.push(am5percent.PieChart.new(root, {
                    layout: root.verticalLayout,
                }));
                let series = chart.series.push(am5percent.PieSeries.new(root, {
                    valueField: "value",
                    categoryField: "key",
                    legendLabelText: "{category}: {value.percent.formatNumber('#.0')} ({value})",
                    // tooltipText: "{category}: {value.percent.formatNumber('#.0')}% ({value})",
                    // legendValueText: "{value.percent.formatNumber('#.0')} " + chartId.indexOf("water") ? `(${this.config.resources.waterConsumptionUnitInMtereCube})` : `(${this.config.resources.electricityConsumptionUnit})`
                }));
                if (semiPieChart) {
                    chart.set("innerRadius", 50);
                    chart.set("startAngle", 180);
                    chart.set("endAngle", 360);
                    series.set("startAngle", 180);
                    series.set("endAngle", 360);
                    series.states.create("hidden", {
                        startAngle: 180,
                        endAngle: 360
                    });
                    series.slices.template.setAll({
                        cornerRadius: 5
                    });
                    series.labels.template.set("visible", false);
                    series.ticks.template.set("visible", false);
                }
                series.data.setAll(chartData);
                let legend = chart.children.push(am5.Legend.new(root, {
                    centerX: am5.percent(50),
                    x: am5.percent(50),
                    marginTop: 15,
                    marginBottom: 15
                }));
                legend.data.setAll(series.dataItems);
                series.appear(1000, 100);
                // remove amcharts watermark
                root._logo?.dispose();
                root.numberFormatter.setAll({
                    numberFormat: "#.00 a",
                    bigNumberPrefixes: [
                        { number: 1e+3, suffix: " K" },
                        { number: 1e+6, suffix: " M" },
                        { number: 1e+9, suffix: " B" },
                        { number: 1e+12, suffix: " T" },
                        { number: 1e+15, suffix: " Qa" },
                        { number: 1e+18, suffix: " Qi" },
                        { number: 1e+21, suffix: " Sx" },
                    ],
                });
                // listen if charts data are changed
                this.eventsService.reportsChartsDataEvent.subscribe((updatedData) => {
                    if (updatedData &&
                        updatedData.length > 0 &&
                        updatedData[0].additionalProperties.chartId == mainChartID &&
                        updatedData[0].additionalProperties.action == "reset") {
                        series.data.setAll([]);
                    }
                    else {
                        if (updatedData && updatedData.length > 0 && updatedData[0].additionalProperties.chartId == mainChartID) {
                            series.data.setAll(updatedData);
                        }
                    }
                    legend.data.setAll(series.dataItems);
                });
            });
        }
        catch (error) {
            console.error("generateAmChart error ", error);
        }
        return root;
    };
    sankeyChartGeneration = (chartId) => {
        let mainChartID = chartId;
        chartId = chartId.replace("_print", "");
        let root = am5.Root.new(mainChartID);
        try {
            this.browserOnly(async () => {
                // const customResponsive = am5themes_Responsive.new(root);
                root.setThemes([
                    am5themes_Animated.new(root),
                    // customResponsive //custom responsive theme
                ]);
                let series = root.container.children.push(am5flow.Sankey.new(root, {
                    sourceIdField: "from",
                    targetIdField: "to",
                    valueField: "value",
                    paddingRight: 150,
                    // paddingTop: 15,
                    nodePadding: 15,
                }));
                series.nodes.get("colors").set("step", 2);
                series.links.template.setAll({
                    fillStyle: "gradient",
                    fillOpacity: .65
                });
                root.numberFormatter.setAll({
                    numberFormat: "#.00 a",
                    bigNumberPrefixes: [
                        { number: 1e+3, suffix: " K" },
                        { number: 1e+6, suffix: " M" },
                        { number: 1e+9, suffix: " B" },
                        { number: 1e+12, suffix: " T" },
                        { number: 1e+15, suffix: " Qa" },
                        { number: 1e+18, suffix: " Qi" },
                        { number: 1e+21, suffix: " Sx" },
                    ],
                });
                series.nodes.labels.template.setAll({
                    fontSize: 12,
                    fontWeight: "500",
                    maxWidth: 150,
                    // oversizedBehavior: "wrap",
                    oversizedBehavior: "truncate",
                    ellipsis: "...",
                    // tooltipText: "{category}",
                    x: am5.percent(110),
                    centerX: am5.percent(0),
                    y: am5.percent(50),
                    centerY: am5.percent(50),
                    paddingLeft: 0,
                    paddingRight: 0
                });
                series.appear(1000, 100);
                // remove amcharts watermark
                root._logo?.dispose();
                // listen if charts data are changed
                this.eventsService.reportsChartsDataEvent.subscribe((updatedData) => {
                    if (updatedData &&
                        updatedData.length > 0 &&
                        updatedData[0].additionalProperties.chartId == mainChartID &&
                        updatedData[0].additionalProperties.action == "reset") {
                        series.data.setAll([]);
                    }
                    else {
                        if (updatedData && updatedData.length > 0 && updatedData[0].additionalProperties.chartId == mainChartID) {
                            series.data.setAll(updatedData);
                        }
                    }
                    // series.nodes.template.events.on("click", (event: any) => {
                    //     const clickedNode = event.target;
                    // // Toggle visibility of clicked node
                    // clickedNode.hide(!clickedNode.isHidden);
                    // // Toggle visibility of links connected to the clicked node
                    // series.links.each((link: any) => {
                    //     if (link.source == clickedNode || link.target == clickedNode) {
                    //         link.hide(!clickedNode.isHidden);
                    //     }
                    // });
                    // });
                });
            });
        }
        catch (error) {
            console.error("generateAmChart error ", error);
        }
        return root;
    };
    formatLargeNumberAbbreviation = (value) => {
        try {
            if (Math.abs(value) >= 1e21) {
                return (value / 1e21).toFixed(2) + " Sx";
            }
            else if (Math.abs(value) >= 1e18) {
                return (value / 1e18).toFixed(2) + " Qi";
            }
            else if (Math.abs(value) >= 1e15) {
                return (value / 1e15).toFixed(2) + " Qa";
            }
            else if (Math.abs(value) >= 1e12) {
                return (value / 1e12).toFixed(2) + " T";
            }
            else if (Math.abs(value) >= 1e9) {
                return (value / 1e9).toFixed(2) + " B";
            }
            else if (Math.abs(value) >= 1e6) {
                return (value / 1e6).toFixed(2) + " M";
            }
            else if (Math.abs(value) >= 1e3) {
                return (value / 1e3).toFixed(2) + " K";
            }
            else {
                return value.toFixed(2).toString();
            }
        }
        catch (error) {
            console.error(error);
            return value.toFixed(2).toString();
        }
    };
    formatNumber = (value) => {
        try {
            if (!isNaN(Number(value))) {
                return Number(value).toLocaleString();
            }
            else {
                return value;
            }
        }
        catch (error) {
            return value;
        }
    };
    capitalizeFirstLetter = (str) => {
        try {
            return str.toLowerCase().replace(/\b\w/g, (char) => char.toUpperCase());
        }
        catch (error) {
            console.error(error);
            return str;
        }
    };
    groupChartsDataByKey = (data, key, value, additionalProperties) => {
        try {
            let _groupedData = _.mapValues(_.groupBy(data, //array
            key), //field to group by
            (arr) => _.sumBy(arr, value) // sum value field
            );
            let groupedDataModel = [];
            Object.keys(_groupedData).forEach((key) => {
                groupedDataModel.push({
                    key: key,
                    value: _groupedData[key],
                    additionalProperties: additionalProperties
                });
            });
            return groupedDataModel;
        }
        catch (error) {
            console.error(error);
            return data;
        }
    };
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChartHelper, deps: [{ token: PLATFORM_ID }, { token: ConfigService }, { token: i1.HttpClient }, { token: ArcgisService }, { token: i0.NgZone }, { token: EventsService }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChartHelper, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChartHelper, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }, { type: ConfigService }, { type: i1.HttpClient }, { type: ArcgisService }, { type: i0.NgZone }, { type: EventsService }] });

class GptDialogComponent {
    data;
    cdr;
    arcgisService;
    configService;
    chartHelper;
    dataTable = []; // Accept data dynamically
    chart_type = '';
    dataIncludeObjectIds = false;
    response_type = 'chart';
    minimize = false;
    geoAIPieChartId = 'geoAIPieChartId';
    geoAIBarChartId = 'geoAIBarChartId';
    geoAILineChartId = 'geoAILineChartId';
    dataSource = new MatTableDataSource(this.dataTable); // Initialize data source
    displayedColumns = []; // Dynamic column names
    paginator;
    sort;
    constructor(data, cdr, arcgisService, configService, chartHelper) {
        this.data = data;
        this.cdr = cdr;
        this.arcgisService = arcgisService;
        this.configService = configService;
        this.chartHelper = chartHelper;
    }
    ngOnInit() {
        if (this.data.response_data) {
            this.response_type = this.data.response_data.type;
            const data = this.data.response_data.last_response;
            this.dataIncludeObjectIds = false;
            if (this.response_type == 'table') {
                const table_data = data.KA_Bot;
                this.displayedColumns = Object.keys(table_data[0]);
                this.dataSource.data = table_data;
                if (this.displayedColumns.includes('OBJECTID')) {
                    this.dataIncludeObjectIds = true;
                }
                this.cdr.detectChanges(); // Ensure DOM updates
            }
            else if (this.response_type == 'chart') {
                const chart_type = data.type;
                this.chart_type = chart_type;
                this.cdr.detectChanges();
                console.log(data);
                console.log(data);
                if (chart_type.toLowerCase() == 'pie') {
                    this.generateRandomId('geoAIPieChartId', data);
                }
                else if (chart_type.toLowerCase() == 'bar') {
                    this.generateRandomId('geoAIBarChartId', data);
                }
                else if (chart_type.toLowerCase() == 'line') {
                    this.generateRandomId('geoAILineChartId', data);
                }
            }
        }
    }
    async renderPieChart(data) {
        const X_data = data.X_data;
        const x_title = data.x_title;
        const Y_data = data.Y_data;
        const y_title = data.y_title;
        // Combine the two arrays into the desired format
        const chart_Data = X_data.map((category, index) => ({
            key: category,
            value: Y_data[index],
        }));
        this.chartHelper.pieChartGeneration(this.geoAIPieChartId, chart_Data, x_title, y_title);
    }
    async renderBarChart(data) {
        const X_data = data.X_data;
        const x_title = data.x_title;
        const Y_data = data.Y_data;
        const y_title = data.y_title;
        // Combine the two arrays into the desired format
        const chart_Data = X_data.map((category, index) => ({
            key: category,
            value: Y_data[index],
        }));
        this.chartHelper.barChartGeneration(this.geoAIBarChartId, chart_Data, x_title, y_title);
    }
    async renderLineChart(data) {
        const X_data = data.X_data;
        const x_title = data.x_title;
        const Y_data = data.Y_data;
        const y_title = data.y_title;
        // Combine the two arrays into the desired format
        const chart_Data = X_data.map((category, index) => ({
            key: category,
            value: Y_data[index],
        }));
        this.chartHelper.lineChartGeneration(this.geoAILineChartId, chart_Data, x_title, y_title);
    }
    generateRandomId(baseId, data) {
        const randomNumber = Math.floor(Math.random() * 1000) + 1;
        const randomId = `${baseId}_${randomNumber}`;
        switch (baseId) {
            case 'geoAIPieChartId':
                this.geoAIPieChartId = randomId;
                this.cdr.detectChanges();
                this.renderPieChart(data);
                break;
            case 'geoAIBarChartId':
                this.geoAIBarChartId = randomId;
                this.cdr.detectChanges();
                this.renderBarChart(data);
                break;
            case 'geoAILineChartId':
                this.geoAILineChartId = randomId;
                this.cdr.detectChanges();
                this.renderLineChart(data);
                break;
            default:
                console.error('Invalid baseId provided');
        }
        console.log(`Generated ID for ${baseId}: ${randomId}`);
    }
    showOnMap() {
        // Show the data on the map
        const data = this.dataSource.filteredData ?? this.dataSource.data;
        const objectIdKey = Object.keys(data[0]).find(key => key.includes("OBJECTID"));
        if (objectIdKey) {
            const objectIDs = data.map((item) => `${item[objectIdKey]}`).join(", ");
            const whereClauses = `OBJECTID IN (${objectIDs})`;
            console.log(whereClauses); // Debugging output
            const mapView = this.configService.config.mapView;
            const highlightLayerTitle = this.data.response_data?.Table_Name;
            this.minimize = true;
            this.arcgisService.highlightFeatures(mapView, highlightLayerTitle, whereClauses, "table");
        }
        else {
            console.error("No OBJECTID-related column found in the data.");
        }
    }
    exportAsImage() {
        // Find the chart div by its ID
        let chartElement = document.getElementById(this.geoAIPieChartId);
        let linkToDownload = this.geoAIPieChartId;
        if (!chartElement) {
            chartElement = document.getElementById(this.geoAIBarChartId);
            linkToDownload = this.geoAIBarChartId;
        }
        if (!chartElement) {
            chartElement = document.getElementById(this.geoAILineChartId);
            linkToDownload = this.geoAILineChartId;
        }
        if (chartElement) {
            // Get computed styles and bounding box of the chart element
            const computedStyle = getComputedStyle(chartElement);
            const padding = {
                top: parseFloat(computedStyle.paddingTop || '0'),
                left: parseFloat(computedStyle.paddingLeft || '0'),
            };
            const { width, height } = chartElement.getBoundingClientRect();
            // Adjust for device pixel ratio
            const scale = window.devicePixelRatio || 1;
            // Create a canvas element with adjusted dimensions
            const canvas = document.createElement('canvas');
            canvas.width = Math.ceil((width + padding.left * 2) * scale);
            canvas.height = Math.ceil((height + padding.top * 2) * scale);
            const context = canvas.getContext('2d');
            if (context) {
                // Scale the context to handle high DPI screens
                context.scale(scale, scale);
                // Set a background color
                context.fillStyle = 'white'; // Or dynamically fetched background
                context.fillRect(0, 0, canvas.width / scale, canvas.height / scale);
                // Get all child canvas elements
                const childCanvases = chartElement.querySelectorAll('canvas');
                childCanvases.forEach((childCanvas) => {
                    if (childCanvas) {
                        // Get relative position of the child canvas to the chart element
                        const { left, top, width: childWidth, height: childHeight } = childCanvas.getBoundingClientRect();
                        if (chartElement) {
                            const offsetX = left - chartElement.getBoundingClientRect().left + padding.left;
                            const offsetY = top - chartElement.getBoundingClientRect().top + padding.top;
                            // Copy the child canvas content into the main canvas
                            context.drawImage(childCanvas, offsetX, offsetY, childWidth, childHeight);
                        }
                    }
                });
                // Export the canvas as an image
                const imageData = canvas.toDataURL('image/png');
                // Create a temporary anchor element to trigger the download
                const link = document.createElement('a');
                link.href = imageData;
                link.download = `${linkToDownload}.png`;
                // Trigger the download
                link.click();
                // Clean up
                link.remove();
            }
        }
        else {
            console.error(`Chart with ID ${linkToDownload} not found.`);
        }
    }
    exportTableData() {
        const dataToExport = this.dataSource.data; // Get data from the dataSource
        const csvRows = [];
        // Add headers
        const headers = this.displayedColumns.join(',');
        csvRows.push(headers);
        // Add rows
        for (const row of dataToExport) {
            const values = this.displayedColumns.map(column => row[column]);
            csvRows.push(values.join(','));
        }
        // Create CSV string
        const csvContent = csvRows.join('\n');
        // Create Blob and download
        const blob = new Blob([csvContent], { type: 'text/csv;charset=utf-8;' });
        const url = URL.createObjectURL(blob);
        const now = new Date();
        const formattedDate = now.toISOString().slice(0, 16).replace('T', ' '); // Format as "yyyy-mm-dd hh:mm"
        const link = document.createElement('a');
        link.setAttribute('href', url);
        link.setAttribute('download', `${formattedDate}.csv`);
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
    }
    ngAfterViewInit() {
        this.dataSource.paginator = this.paginator;
        this.dataSource.sort = this.sort;
    }
    applyFilter(event) {
        const filterValue = event.target.value
            .trim()
            .toLowerCase();
        this.dataSource.filter = filterValue;
    }
    minimizeWidget(minimize) {
        this.minimize = minimize;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: GptDialogComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i0.ChangeDetectorRef }, { token: ArcgisService }, { token: ConfigService }, { token: ChartHelper }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.4", type: GptDialogComponent, isStandalone: false, selector: "app-gpt-dialog", viewQueries: [{ propertyName: "paginator", first: true, predicate: MatPaginator, descendants: true }, { propertyName: "sort", first: true, predicate: MatSort, descendants: true }], ngImport: i0, template: "<div mat-dialog-content>\n    <div>\n    <div class=\"geo-gpt-close\">\n      <div *ngIf=\"response_type === 'table'\">\n        <a *ngIf=\"!minimize\" (click)=\"minimizeWidget(true)\"><mat-icon>keyboard_arrow_up</mat-icon></a>\n        <a *ngIf=\"minimize\" (click)=\"minimizeWidget(false)\"><mat-icon>keyboard_arrow_down</mat-icon></a>\n      </div>\n        <button class=\"close-button\" mat-icon-button aria-label=\"\" mat-dialog-close>\n          <img src=\"assets/icons/close-cross.svg\" />\n        </button>\n    </div>\n    <div class=\"geo-gpt-widgets {{minimize?'minimize':''}}\" *ngIf=\"response_type === 'table' && data.response_data.last_response?.KA_Bot?.length > 0\">\n      <div class=\"geo-gpt-table-buttons\">\n    <mat-form-field appearance=\"outline\">\n      <mat-label>Filter</mat-label>\n      <input matInput (keyup)=\"applyFilter($event)\" placeholder=\"Search data\" />\n    </mat-form-field>\n    <div class=\"table-buttons-export\">\n      <button mat-raised-button color=\"primary\" (click)=\"showOnMap()\" *ngIf=\"dataIncludeObjectIds\">Show<mat-icon>map</mat-icon></button>\n      <button mat-raised-button color=\"primary\" (click)=\"exportTableData()\">CSV<mat-icon>download</mat-icon></button>\n    </div>\n  </div>\n  <div class=\"geo-gpt-table-container\">\n    <table mat-table [dataSource]=\"dataSource\" class=\"mat-elevation-z8 geo-gpt-table\" matSort>\n      <!-- Dynamic Columns -->\n      <ng-container *ngFor=\"let column of displayedColumns\" [matColumnDef]=\"column\">\n        <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ column }}</th>\n        <td mat-cell *matCellDef=\"let element\">{{ element[column] }}</td>\n      </ng-container>\n  \n      <!-- Header Row -->\n      <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n  \n      <!-- Data Row -->\n      <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\"></tr>\n    </table>\n  </div>\n    <!-- Paginator -->\n    <mat-paginator\n      [pageSize]=\"5\"\n      [pageSizeOptions]=\"[5, 10, 20]\"\n      showFirstLastButtons\n    ></mat-paginator>\n  </div>\n  </div>\n  <div *ngIf=\"response_type === 'chart'\">\n    <div dir=\"ltr\" id=\"chart\"  >\n    <div [id]=\"geoAIPieChartId\" class=\"chart-pie\" *ngIf=\"chart_type === 'Pie'\"></div>\n    <div [id]=\"geoAIBarChartId\" class=\"chart-bar\" *ngIf=\"chart_type === 'Bar'\"></div>\n    <div [id]=\"geoAILineChartId\" class=\"chart-line\" *ngIf=\"chart_type === 'Line'\"></div>\n  </div>\n    <div class=\"geo-gpt-chart-buttons\">\n      <button mat-raised-button color=\"primary\" (click)=\"exportAsImage()\">Export As Image</button>\n    </div>\n  </div>\n  </div>\n  \n  ", styles: [".geo-gpt-table-container{overflow-x:auto;height:100%}.geo-gpt-table{width:100%}.geo-gpt-table th{line-height:12px;letter-spacing:.01em}.geo-gpt-table td{line-height:15px;border:0;padding-block:2px}.geo-gpt-close{display:flex;justify-content:end}.geo-gpt-close a{cursor:pointer;padding:10px}#chart,.chart-pie,.chart-bar,.chart-line{width:100%;height:400px}.geo-gpt-table-buttons{display:flex;justify-content:space-between;margin-top:10px;height:40px!important}.geo-gpt-table-buttons .table-buttons-export{display:flex;gap:10px}.geo-gpt-chart-buttons{display:flex;justify-content:center;margin-top:10px}.geo-gpt-widgets{height:100%;overflow:hidden;display:flex;flex-direction:column;transition:all .5s ease-in}.geo-gpt-widgets.minimize{height:0px}.geo-gpt-mat-header-cell{color:#4c5e69!important}.close-button{background-color:#7d9aaa}:host ::ng-deep mat-select,:host ::ng-deep .mat-select-min-line,:host ::ng-deep .mat-select-arrow{color:#4c5e69!important}:host ::ng-deep .mat-dialog-content{max-height:80vh!important;overflow:hidden!important}:host ::ng-deep .mat-input-element{color:#4c5e69!important}\n"], dependencies: [{ kind: "directive", type: i4$1.Dir, selector: "[dir]", inputs: ["dir"], outputs: ["dirChange"], exportAs: ["dir"] }, { kind: "component", type: i5$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "component", type: i5$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "directive", type: i3$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i3$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i5$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i5$2.MatLabel, selector: "mat-label" }, { kind: "component", type: i10.MatPaginator, selector: "mat-paginator", inputs: ["color", "pageIndex", "length", "pageSize", "pageSizeOptions", "hidePageSize", "showFirstLastButtons", "selectConfig", "disabled"], outputs: ["page"], exportAs: ["matPaginator"] }, { kind: "directive", type: i11.MatSort, selector: "[matSort]", inputs: ["matSortActive", "matSortStart", "matSortDirection", "matSortDisableClear", "matSortDisabled"], outputs: ["matSortChange"], exportAs: ["matSort"] }, { kind: "component", type: i11.MatSortHeader, selector: "[mat-sort-header]", inputs: ["mat-sort-header", "arrowPosition", "start", "disabled", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { kind: "component", type: i12.MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { kind: "directive", type: i12.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { kind: "directive", type: i12.MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { kind: "directive", type: i12.MatColumnDef, selector: "[matColumnDef]", inputs: ["matColumnDef"] }, { kind: "directive", type: i12.MatCellDef, selector: "[matCellDef]" }, { kind: "directive", type: i12.MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }, { kind: "directive", type: i12.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { kind: "directive", type: i12.MatCell, selector: "mat-cell, td[mat-cell]" }, { kind: "component", type: i12.MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { kind: "component", type: i12.MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }, { kind: "directive", type: i9.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i9.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: GptDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-gpt-dialog', standalone: false, template: "<div mat-dialog-content>\n    <div>\n    <div class=\"geo-gpt-close\">\n      <div *ngIf=\"response_type === 'table'\">\n        <a *ngIf=\"!minimize\" (click)=\"minimizeWidget(true)\"><mat-icon>keyboard_arrow_up</mat-icon></a>\n        <a *ngIf=\"minimize\" (click)=\"minimizeWidget(false)\"><mat-icon>keyboard_arrow_down</mat-icon></a>\n      </div>\n        <button class=\"close-button\" mat-icon-button aria-label=\"\" mat-dialog-close>\n          <img src=\"assets/icons/close-cross.svg\" />\n        </button>\n    </div>\n    <div class=\"geo-gpt-widgets {{minimize?'minimize':''}}\" *ngIf=\"response_type === 'table' && data.response_data.last_response?.KA_Bot?.length > 0\">\n      <div class=\"geo-gpt-table-buttons\">\n    <mat-form-field appearance=\"outline\">\n      <mat-label>Filter</mat-label>\n      <input matInput (keyup)=\"applyFilter($event)\" placeholder=\"Search data\" />\n    </mat-form-field>\n    <div class=\"table-buttons-export\">\n      <button mat-raised-button color=\"primary\" (click)=\"showOnMap()\" *ngIf=\"dataIncludeObjectIds\">Show<mat-icon>map</mat-icon></button>\n      <button mat-raised-button color=\"primary\" (click)=\"exportTableData()\">CSV<mat-icon>download</mat-icon></button>\n    </div>\n  </div>\n  <div class=\"geo-gpt-table-container\">\n    <table mat-table [dataSource]=\"dataSource\" class=\"mat-elevation-z8 geo-gpt-table\" matSort>\n      <!-- Dynamic Columns -->\n      <ng-container *ngFor=\"let column of displayedColumns\" [matColumnDef]=\"column\">\n        <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ column }}</th>\n        <td mat-cell *matCellDef=\"let element\">{{ element[column] }}</td>\n      </ng-container>\n  \n      <!-- Header Row -->\n      <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n  \n      <!-- Data Row -->\n      <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\"></tr>\n    </table>\n  </div>\n    <!-- Paginator -->\n    <mat-paginator\n      [pageSize]=\"5\"\n      [pageSizeOptions]=\"[5, 10, 20]\"\n      showFirstLastButtons\n    ></mat-paginator>\n  </div>\n  </div>\n  <div *ngIf=\"response_type === 'chart'\">\n    <div dir=\"ltr\" id=\"chart\"  >\n    <div [id]=\"geoAIPieChartId\" class=\"chart-pie\" *ngIf=\"chart_type === 'Pie'\"></div>\n    <div [id]=\"geoAIBarChartId\" class=\"chart-bar\" *ngIf=\"chart_type === 'Bar'\"></div>\n    <div [id]=\"geoAILineChartId\" class=\"chart-line\" *ngIf=\"chart_type === 'Line'\"></div>\n  </div>\n    <div class=\"geo-gpt-chart-buttons\">\n      <button mat-raised-button color=\"primary\" (click)=\"exportAsImage()\">Export As Image</button>\n    </div>\n  </div>\n  </div>\n  \n  ", styles: [".geo-gpt-table-container{overflow-x:auto;height:100%}.geo-gpt-table{width:100%}.geo-gpt-table th{line-height:12px;letter-spacing:.01em}.geo-gpt-table td{line-height:15px;border:0;padding-block:2px}.geo-gpt-close{display:flex;justify-content:end}.geo-gpt-close a{cursor:pointer;padding:10px}#chart,.chart-pie,.chart-bar,.chart-line{width:100%;height:400px}.geo-gpt-table-buttons{display:flex;justify-content:space-between;margin-top:10px;height:40px!important}.geo-gpt-table-buttons .table-buttons-export{display:flex;gap:10px}.geo-gpt-chart-buttons{display:flex;justify-content:center;margin-top:10px}.geo-gpt-widgets{height:100%;overflow:hidden;display:flex;flex-direction:column;transition:all .5s ease-in}.geo-gpt-widgets.minimize{height:0px}.geo-gpt-mat-header-cell{color:#4c5e69!important}.close-button{background-color:#7d9aaa}:host ::ng-deep mat-select,:host ::ng-deep .mat-select-min-line,:host ::ng-deep .mat-select-arrow{color:#4c5e69!important}:host ::ng-deep .mat-dialog-content{max-height:80vh!important;overflow:hidden!important}:host ::ng-deep .mat-input-element{color:#4c5e69!important}\n"] }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i0.ChangeDetectorRef }, { type: ArcgisService }, { type: ConfigService }, { type: ChartHelper }], propDecorators: { paginator: [{
                type: ViewChild,
                args: [MatPaginator]
            }], sort: [{
                type: ViewChild,
                args: [MatSort]
            }] } });

class ChatService {
    arcgisService;
    dialog;
    configService;
    // Inject the ArcGIS service
    historyIndex = -1;
    commandHistory = [];
    isLoading = false;
    response_data = {};
    message = '';
    messageCounter = 0;
    messages = [
        {
            id: 0,
            sender: 'bot',
            content: 'Hi there! How can I help you with GIS today?',
            timestamp: new Date(),
            type: 'text',
        },
    ];
    constructor(arcgisService, dialog, configService) {
        this.arcgisService = arcgisService;
        this.dialog = dialog;
        this.configService = configService;
    }
    sendChatMessage() {
        const myHeaders = new Headers();
        var geo_gpt_session_id = localStorage.getItem('geo_gpt_session_id');
        geo_gpt_session_id != 'undefined' && geo_gpt_session_id != null
            ? localStorage.setItem('geo_gpt_session_id', geo_gpt_session_id)
            : localStorage.setItem('geo_gpt_session_id', '');
        geo_gpt_session_id = localStorage.getItem('geo_gpt_session_id');
        myHeaders.append('Content-Type', 'application/json');
        const raw = JSON.stringify({
            query: this.message,
            session_id: geo_gpt_session_id,
            document: 0,
        });
        const requestOptions = {
            method: 'POST',
            headers: myHeaders,
            body: raw,
            redirect: 'follow',
        };
        // Clear the input
        this.message = '';
        const geo_gpt_url = this.configService.config.webapiConfig.geoGptUrl;
        fetch(geo_gpt_url, requestOptions)
            .then((response) => response.json()) // Parse the JSON response
            .then((data) => {
            if (data?.error) {
                localStorage.setItem('geo_gpt_session_id', '');
                this.isLoading = false;
                localStorage.setItem('geo_gpt_session_id', '');
                const retrySuggestions = [
                    "Hmm, that didn’t quite come through. Can you send it once more?",
                    "I didn’t catch that. Could you try sending it again?",
                    "Oops, I missed that! Can you send it again, please?",
                    "Looks like that didn’t work. Mind trying again?",
                    "Oh no, I didn’t quite get that. Would you mind sending it once more?"
                ];
                // Choose a random suggestion for the bot message
                const randomRetrySuggestion = retrySuggestions[Math.floor(Math.random() * retrySuggestions.length)];
                this.messages.push({
                    id: this.messageCounter++,
                    sender: 'bot',
                    content: randomRetrySuggestion,
                    timestamp: new Date(),
                    type: 'bot'
                });
            }
            const session_id = data.session_id;
            localStorage.setItem('geo_gpt_session_id', session_id);
            this.response_data = data;
            const data_type = data.type;
            if (data_type == 'text') {
                const last_response = data.last_response.KA_Bot;
                this.messages.push({
                    id: this.messageCounter++,
                    sender: 'bot',
                    content: last_response,
                    timestamp: new Date(),
                    type: data_type,
                });
                this.isLoading = false;
            }
            else if (data_type == 'table' || data_type == 'chart') {
                this.showDataByType(data_type);
            }
            else if (data_type == 'map') {
                this.isLoading = false;
                setTimeout(() => {
                    this.checkMapFunctions(data.last_response);
                }, 1000);
            }
            // Hide the loading spinner after receiving the response
            // Scroll to the bottom of the chat box
            // Trigger change detection and then scroll
        })
            .catch((error) => {
            localStorage.setItem('geo_gpt_session_id', '');
            // Hide the loading spinner after receiving the response
            this.isLoading = false;
        });
    }
    showDataByType(data_type) {
        this.isLoading = false;
        this.setTypingAnimation(true, data_type);
    }
    setTypingAnimation(openDialog = false, data_type = 'bot') {
        this.messages.push({
            id: this.messageCounter++,
            sender: 'bot',
            content: '.',
            timestamp: new Date(),
            type: data_type,
        });
        let typingIndicator; // For interval reference
        // Get the reference to the typing indicator message
        const typingMessageIndex = this.messages.length - 1;
        // Start the animation
        typingIndicator = setInterval(() => {
            const currentText = this.messages[typingMessageIndex].content;
            if (currentText === '.') {
                this.messages[typingMessageIndex].content = '..';
            }
            else if (currentText === '..') {
                this.messages[typingMessageIndex].content = '...';
            }
            else if (currentText === '...') {
                this.messages[typingMessageIndex].content = '....';
            }
            else if (currentText === '....') {
                this.messages[typingMessageIndex].content = '.....';
            }
            else {
                this.messages[typingMessageIndex].content = '.';
            }
            // Trigger change detection if required (e.g., when using OnPush strategy)
        }, 500); // Update every 500ms
        setTimeout(() => {
            // Stop the animation
            clearInterval(typingIndicator);
            // Replace the typing indicator with the actual response
            this.messages[typingMessageIndex].content = '.....';
            if (this.response_data.type == "table" || this.response_data.type == "chart") {
                if (openDialog && ((this.response_data.type == "table" && this.response_data.last_response.KA_Bot.length > 0)
                    || (this.response_data.type == "chart" && this.response_data.last_response.X_data.length > 0)))
                    this.openDialog();
                else {
                    this.pushMessageSuggestions();
                }
            }
        }, 500);
    }
    pushMessageSuggestions() {
        const suggestions = [
            "Hmm, I couldn’t find anything that matches. Maybe try a different search?",
            "Looks like there’s nothing here. Can you refine your search?",
            "I didn’t find any results. How about trying a different keyword?",
            "Nothing came up for that. Want to try another search term?",
            "No matches found. You could try adjusting your filters!",
            "I couldn't find anything for that. Maybe you can try using other keywords?",
            "Looks like we didn’t find what you were looking for. How about searching with a different term?",
            "No results came up. Try using more specific terms!",
            "Nothing matched your query. Want to try again with different criteria?"
        ];
        // Choose a random suggestion for the bot message
        const randomSuggestion = suggestions[Math.floor(Math.random() * suggestions.length)];
        this.messages.push({
            id: this.messageCounter++,
            sender: 'bot',
            content: randomSuggestion,
            timestamp: new Date(),
            type: 'table'
        });
    }
    sendMessage() {
        this.commandHistory.push(this.message);
        this.messages.push({
            id: this.messageCounter++,
            sender: 'user',
            content: this.message,
            timestamp: new Date(),
            type: 'user',
        });
        // Show the loading spinner
        this.isLoading = true;
        // Add user's message with time
        this.sendChatMessage();
    }
    async checkMapFunctions(data) {
        await this.openMapDialog();
        const mapView = this.configService.config.mapView;
        if (mapView) {
            console.log("Got mapView after dialog closed:", mapView);
            // Perform operations on the mapView
        }
        const functionName = data.Function;
        const parameters = data.Parameters;
        if (mapView) {
            console.log('Map is loaded, executing function:', functionName);
        }
        else {
            console.error('MapView is not available.');
        }
        this.arcgisService.clearHighlightedFeatures(this.configService.config.mapView);
        switch (functionName) {
            case 'Zoom In':
                const zoomInLevel = parseInt(parameters['Level']);
                this.arcgisService.increaseZoom(mapView, zoomInLevel);
                this.addBotMessage(`Zooming in with level: ${zoomInLevel}`);
                // console.log(`Zooming in with level: ${zoomInLevel}`);
                this.isLoading = false;
                break;
            case 'Zoom Out':
                const zoomOutLevel = parseInt(parameters['Level']);
                this.arcgisService.decreaseZoom(mapView, zoomOutLevel);
                this.addBotMessage(`Zooming out with level: ${zoomOutLevel}`);
                this.isLoading = false;
                break;
            case 'Zoom To':
                const zoomToLocation = parameters['locationName'] ?? parameters['LocationName'];
                this.arcgisService.zoomToLocation(mapView, zoomToLocation);
                this.addBotMessage(`Zooming to the specified location: ${zoomToLocation}`);
                this.isLoading = false;
                break;
            case 'Full Extent':
                const fullExtentLayerTitle = parameters['LayerTitle'];
                if (this.arcgisService.zoomToFullExtent(mapView, fullExtentLayerTitle))
                    this.addBotMessage(`Setting full extent for layer: ${fullExtentLayerTitle}`);
                else
                    this.addBotMessage(`Setting full extent for layer: ${fullExtentLayerTitle} failed`);
                this.isLoading = false;
                break;
            case 'Add Data':
                const addDataUrl = parameters['DataURL'];
                this.arcgisService.addLayerFromURL(mapView, addDataUrl);
                this.addBotMessage(`Adding data from: ${addDataUrl}`);
                this.isLoading = false;
                break;
            case 'Basemap Gallery':
            case 'Basemap Switcher':
                const basemapName = parameters['BasemapName'];
                this.arcgisService.switchBasemap(mapView, basemapName);
                this.addBotMessage(`Selecting basemap: ${basemapName}`);
                this.isLoading = false;
                break;
            case 'Layer Transparency':
                const layerTitle = parameters['LayerTitle'];
                const opacity = parameters['Opacity'];
                if (this.arcgisService.changeLayerOpacity(mapView, layerTitle, opacity))
                    this.addBotMessage(`Setting transparency for ${layerTitle} to ${opacity}`);
                else
                    this.addBotMessage(`Setting transparency for ${layerTitle} to ${opacity} failed`);
                this.isLoading = false;
                break;
            case 'Add Layer':
                const addLayerUrl = parameters['DataURL'];
                this.arcgisService.addLayerFromURL(mapView, addLayerUrl);
                this.addBotMessage(`Adding layer from: ${addLayerUrl}`);
                this.isLoading = false;
                break;
            case 'Show Legend':
                this.arcgisService.addLegendList(mapView);
                this.addBotMessage('Showing legend');
                break;
            case 'Show LayerList':
                this.arcgisService.addLayerList(mapView);
                this.addBotMessage('Showing layer list ');
                break;
            case 'Remove Layer':
                const removeLayerTitle = parameters['LayerTitle'];
                this.arcgisService.removeLayerByTitle(mapView, removeLayerTitle);
                this.addBotMessage(`Removing layer: ${removeLayerTitle}`);
                this.isLoading = false;
                break;
            case 'Highlight Features':
                const highlightLayerTitle = parameters['LayerTitle'];
                const whereClause = parameters['WhereClause'];
                const isHighlighted = await this.arcgisService.highlightFeatures(mapView, highlightLayerTitle, whereClause, 'map');
                if (isHighlighted)
                    this.addBotMessage(`Highlighting features on ${highlightLayerTitle}`);
                else
                    this.addBotMessage(`No features found to highlight on ${highlightLayerTitle} layer`);
                this.isLoading = false;
                break;
            case 'Layer Query':
                const queryLayerTitle = parameters['LayerTitle'];
                const queryWhereClause = parameters['WhereClause'];
                this.arcgisService.queryLayer(mapView, queryLayerTitle, queryWhereClause);
                this.addBotMessage(`Querying ${queryLayerTitle}`);
                this.isLoading = false;
                break;
            case 'Layer Reordering':
                const reorderingLayerTitle = parameters['LayerTitle'];
                const order = parameters['Order'];
                this.arcgisService.reorderLayer(mapView, reorderingLayerTitle, order);
                this.addBotMessage(`Reordering ${reorderingLayerTitle} to order: ${order}`);
                this.isLoading = false;
                break;
            case 'Previous Extent':
                var msg = this.arcgisService.zoomToPrevious(mapView);
                this.addBotMessage('Moving to previous extent (no parameters)\n' + msg);
                this.isLoading = false;
                break;
            case 'Next Extent':
                var msg = this.arcgisService.zoomToNext(mapView);
                this.addBotMessage('Moving to next extent (no parameters)\n' + msg);
                this.isLoading = false;
                break;
            case 'Export Map':
                this.arcgisService
                    .printService(mapView)
                    .then((html) => {
                    this.addBotMessage(html);
                    this.isLoading = false;
                })
                    .catch((error) => {
                    console.error(error);
                    this.pushMessageSuggestions();
                    this.isLoading = false;
                });
                break;
            case 'Map Full Extent':
                this.arcgisService.goToMapFullExtent(mapView);
                this.addBotMessage('Zoom To initial Extent');
                this.isLoading = false;
                break;
            case 'Clear Highlight':
                this.arcgisService.clearHighlightedFeatures(mapView);
                this.addBotMessage('Highlighted Features Removed');
                this.isLoading = false;
                break;
            case 'Add Bookmark':
                const saveBookmarkName = parameters['BookmarkName'];
                this.arcgisService.addBookmark(mapView, saveBookmarkName);
                this.addBotMessage(`Saving bookmark: ${saveBookmarkName}`);
                break;
            case 'Load Bookmark':
                const loadBookmarkName = parameters['BookmarkName'];
                this.arcgisService.loadBookmarkByName(mapView, loadBookmarkName);
                this.addBotMessage(`Loading bookmark: ${loadBookmarkName}`);
                break;
            default:
                this.addBotMessage(`Unknown command ${functionName}`);
                this.isLoading = false;
                break;
        }
    }
    saveMapConfiguration(url, body) {
        return fetch(url, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(body),
        })
            .then((response) => {
            if (!response.ok) {
                throw new Error(`HTTP error! status: ${response.status}`);
            }
            return response.json();
        })
            .then((data) => {
            return data;
        })
            .catch((error) => {
            console.error('Error:', error);
            throw error;
        });
    }
    addBotMessage(message) {
        // Add user's message with time
        this.messages.push({
            id: this.messageCounter++,
            sender: 'bot',
            content: message,
            timestamp: new Date(),
            type: 'html',
        });
    }
    openMapDialog() {
        try {
            const existingDialog = this.dialog.getDialogById('gpt-map-dialog');
            if (existingDialog) {
                return;
            }
            this.dialog.open(MapComponent, {
                id: 'gpt-map-dialog',
                width: '65%',
                height: '90%',
                position: { top: '20px' },
                disableClose: true,
                hasBackdrop: false
            });
            // dialogRef.afterClosed().subscribe(
            //   (mapView) => {
            //     console.log("Dialog closed, received mapView:", mapView);
            //     resolve(mapView); // Ensure resolution
            //   },
            //   (error) => {
            //     console.error("Dialog closed with error:", error);
            //     reject(error); // Handle rejection
            //   }
            // );
        }
        catch (error) {
            console.error("Error in openMapDialog:", error);
        }
    }
    openDialog() {
        const existingDialog = this.dialog.getDialogById('gpt-dialog');
        if (existingDialog) {
            // Update the dialog's data
            existingDialog.componentInstance.data = {
                response_data: this.response_data,
                config: this.configService.config,
            };
            return; // Stop execution to avoid reopening
        }
        // Open a new dialog if not already open
        this.dialog.open(GptDialogComponent, {
            id: 'gpt-dialog',
            width: '60%',
            height: '80%',
            data: {
                response_data: this.response_data,
                config: this.configService.config,
            },
            position: { top: '60px' }, // Aligns the dialog to the left side
            disableClose: true, // Prevents closing the dialog on outside click or Escape key
            hasBackdrop: false, // Removes the backdrop to allow interaction with the map
        });
    }
    onKeyDown(key) {
        if (key === 'ArrowUp') {
            // Navigate backward through history
            if (this.historyIndex <
                this.commandHistory.length - 1) {
                this.historyIndex++;
                this.message =
                    this.commandHistory[this.commandHistory.length -
                        1 -
                        this.historyIndex];
            }
        }
        else if (key === 'ArrowDown') {
            // Navigate forward through history
            if (this.historyIndex > 0) {
                this.historyIndex--;
                this.message =
                    this.commandHistory[this.commandHistory.length -
                        1 -
                        this.historyIndex];
            }
            else if (this.historyIndex === 0) {
                this.historyIndex--;
                this.message = '';
            }
        }
    }
    clearChat = () => {
        // Inject the ArcGIS service
        this.historyIndex = -1;
        this.commandHistory = [];
        this.isLoading = false;
        this.message = '';
        this.messageCounter = 0;
        this.messages = [
            {
                id: 0,
                sender: 'bot',
                content: 'Hi there! How can I help you with GIS today?',
                timestamp: new Date(),
                type: 'text',
            },
        ];
    };
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChatService, deps: [{ token: ArcgisService }, { token: i3$1.MatDialog }, { token: ConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChatService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChatService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: ArcgisService }, { type: i3$1.MatDialog }, { type: ConfigService }] });

class ChatComponent {
    cdr;
    arcgisService;
    configService;
    eventsService;
    chatService;
    chatBox; // Reference to the chat box
    constructor(cdr, arcgisService, configService, eventsService, chatService) {
        this.cdr = cdr;
        this.arcgisService = arcgisService;
        this.configService = configService;
        this.eventsService = eventsService;
        this.chatService = chatService;
    }
    ngAfterViewInit() {
        this.eventsService.mapLoadedEvent.subscribe((load) => {
            const mapView = this.configService.config.mapView;
            // Ensure the map is fully loaded before performing other actions
            mapView.map.allLayers.forEach((l) => {
                console.log(l.id);
            });
            mapView
                .when(() => {
                // Initialize other components that rely on the map being ready
                //this.mapUtils.initalizeBookmark() // Call after map is loaded
                this.arcgisService.trackingg(mapView); // Call after map is loaded
            })
                .catch((error) => {
                console.error('Error loading the map view:', error);
            });
        });
    }
    sendMessage() {
        if (this.chatService.message.trim()) {
            // Add user's message with time
            setTimeout(() => {
                this.chatService.sendMessage();
            }, 1000);
            setTimeout(() => {
                this.scrollToBottom();
                this.cdr.detectChanges();
            }, 2000);
        }
    }
    onKeyDown(event) {
        this.chatService.onKeyDown(event.key);
    }
    scrollToBottom() {
        // Scroll the chat box to the bottom
        if (this.chatBox) {
            const element = this.chatBox.nativeElement;
            element.scrollTop = element.scrollHeight;
        }
    }
    deleteChat() {
        this.chatService.clearChat();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChatComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: ArcgisService }, { token: ConfigService }, { token: EventsService }, { token: ChatService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.4", type: ChatComponent, isStandalone: false, selector: "app-chat", viewQueries: [{ propertyName: "chatBox", first: true, predicate: ["chatBox"], descendants: true }], ngImport: i0, template: "<div class=\"chat-container\">\r\n  <div class=\"chat-container-button\">\r\n    <button mat-icon-button (click)=\"deleteChat()\" matTooltip=\"Delete Chat\" >\r\n      <mat-icon>delete</mat-icon>\r\n    </button>\r\n</div>\r\n    <div class=\"chat-box\" #chatBox>\r\n      <div *ngFor=\"let message of chatService.messages\" [class]=\"message.sender\">\r\n        <p [innerHTML]=\"message.content\"></p>\r\n        <span class=\"time\">{{ message.timestamp | date : \"medium\" }}</span>\r\n      </div>\r\n    </div>\r\n\r\n  \r\n    <div class=\"chat-input-box\">\r\n      <input\r\n      #userInputField\r\n        type=\"text\"\r\n        [(ngModel)]=\"chatService.message\"\r\n        placeholder=\"Type a message...\"\r\n        (keydown.enter)=\"sendMessage()\" (keydown)=\"onKeyDown($event)\"\r\n      />\r\n      <button class=\"chat-sketch__button\" (click)=\"sendMessage()\" *ngIf=\"!chatService.isLoading\">\r\n        <img src=\"assets/icons/send.svg\" alt=\"\" />\r\n    </button>\r\n       <!-- Loading Spinner -->\r\n    <div *ngIf=\"chatService.isLoading\" class=\"loading-spinner\"></div>\r\n    </div>      \r\n  </div>", styles: [".chat-container{display:flex;flex-direction:column;height:50vh;width:400px;background:#1d2431}.chat-box{flex:1;padding:10px;overflow-y:auto;display:flex;flex-direction:column;gap:10px}.chat-box .user{align-self:flex-end;color:#4c5e69;border:1px solid #9daaca;padding:8px 12px;border-radius:12px 12px 2px;max-width:80%;word-wrap:break-word}.chat-box .bot{align-self:flex-start;background-color:#e9e9e9;color:#4c5e69;padding:8px 12px;border-radius:12px 12px 12px 2px;max-width:95%;word-wrap:break-word}.chat-input-box{display:flex;padding:10px;background:#ffffffb3;border-top:1px solid #ccc;align-items:center;justify-content:center;gap:10px}input[type=text]{flex:1;padding:10px;border:1px solid #ccc;border-radius:5px;margin-right:10px}.chat-sketch__button{border:none;background:transparent;cursor:pointer}.chat-sketch__button img{height:30px;border-radius:10px;background:#7d9aaa;display:flex}.chat-box .user,.chat-box .bot{position:relative;display:inline-block}.chat-box .time{font-size:.8em;margin-top:4px;display:block;text-align:right}.chat-box .bot .time{text-align:left}.loading-spinner{border:4px solid #f3f3f3;border-top:4px solid #7D9AAA;border-radius:50%;width:25px;height:25px;animation:spin 2s linear infinite}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(360deg)}}.chat-container-button{display:flex;justify-content:end}\n"], dependencies: [{ kind: "component", type: i5$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i6.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: i7.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i7.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i7.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i9.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i9.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i9.DatePipe, name: "date" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: ChatComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chat', standalone: false, template: "<div class=\"chat-container\">\r\n  <div class=\"chat-container-button\">\r\n    <button mat-icon-button (click)=\"deleteChat()\" matTooltip=\"Delete Chat\" >\r\n      <mat-icon>delete</mat-icon>\r\n    </button>\r\n</div>\r\n    <div class=\"chat-box\" #chatBox>\r\n      <div *ngFor=\"let message of chatService.messages\" [class]=\"message.sender\">\r\n        <p [innerHTML]=\"message.content\"></p>\r\n        <span class=\"time\">{{ message.timestamp | date : \"medium\" }}</span>\r\n      </div>\r\n    </div>\r\n\r\n  \r\n    <div class=\"chat-input-box\">\r\n      <input\r\n      #userInputField\r\n        type=\"text\"\r\n        [(ngModel)]=\"chatService.message\"\r\n        placeholder=\"Type a message...\"\r\n        (keydown.enter)=\"sendMessage()\" (keydown)=\"onKeyDown($event)\"\r\n      />\r\n      <button class=\"chat-sketch__button\" (click)=\"sendMessage()\" *ngIf=\"!chatService.isLoading\">\r\n        <img src=\"assets/icons/send.svg\" alt=\"\" />\r\n    </button>\r\n       <!-- Loading Spinner -->\r\n    <div *ngIf=\"chatService.isLoading\" class=\"loading-spinner\"></div>\r\n    </div>      \r\n  </div>", styles: [".chat-container{display:flex;flex-direction:column;height:50vh;width:400px;background:#1d2431}.chat-box{flex:1;padding:10px;overflow-y:auto;display:flex;flex-direction:column;gap:10px}.chat-box .user{align-self:flex-end;color:#4c5e69;border:1px solid #9daaca;padding:8px 12px;border-radius:12px 12px 2px;max-width:80%;word-wrap:break-word}.chat-box .bot{align-self:flex-start;background-color:#e9e9e9;color:#4c5e69;padding:8px 12px;border-radius:12px 12px 12px 2px;max-width:95%;word-wrap:break-word}.chat-input-box{display:flex;padding:10px;background:#ffffffb3;border-top:1px solid #ccc;align-items:center;justify-content:center;gap:10px}input[type=text]{flex:1;padding:10px;border:1px solid #ccc;border-radius:5px;margin-right:10px}.chat-sketch__button{border:none;background:transparent;cursor:pointer}.chat-sketch__button img{height:30px;border-radius:10px;background:#7d9aaa;display:flex}.chat-box .user,.chat-box .bot{position:relative;display:inline-block}.chat-box .time{font-size:.8em;margin-top:4px;display:block;text-align:right}.chat-box .bot .time{text-align:left}.loading-spinner{border:4px solid #f3f3f3;border-top:4px solid #7D9AAA;border-radius:50%;width:25px;height:25px;animation:spin 2s linear infinite}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(360deg)}}.chat-container-button{display:flex;justify-content:end}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: ArcgisService }, { type: ConfigService }, { type: EventsService }, { type: ChatService }], propDecorators: { chatBox: [{
                type: ViewChild,
                args: ['chatBox']
            }] } });

class MaterialModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.1.4", ngImport: i0, type: MaterialModule, exports: [A11yModule,
            CdkStepperModule,
            CdkTableModule,
            CdkTreeModule,
            DragDropModule,
            MatAutocompleteModule,
            MatBadgeModule,
            MatBottomSheetModule,
            MatButtonModule,
            MatButtonToggleModule,
            MatCardModule,
            MatCheckboxModule,
            MatChipsModule,
            MatStepperModule,
            MatDatepickerModule,
            MatDialogModule,
            MatDividerModule,
            MatExpansionModule,
            MatGridListModule,
            MatIconModule,
            MatInputModule,
            MatFormFieldModule,
            MatListModule,
            MatMenuModule,
            MatNativeDateModule,
            MatPaginatorModule,
            MatProgressBarModule,
            MatProgressSpinnerModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSliderModule,
            MatSlideToggleModule,
            MatSnackBarModule,
            MatSortModule,
            MatTableModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatTreeModule,
            PortalModule,
            ScrollingModule] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MaterialModule, imports: [A11yModule,
            CdkStepperModule,
            CdkTableModule,
            CdkTreeModule,
            DragDropModule,
            MatAutocompleteModule,
            MatBadgeModule,
            MatBottomSheetModule,
            MatButtonModule,
            MatButtonToggleModule,
            MatCardModule,
            MatCheckboxModule,
            MatChipsModule,
            MatStepperModule,
            MatDatepickerModule,
            MatDialogModule,
            MatDividerModule,
            MatExpansionModule,
            MatGridListModule,
            MatIconModule,
            MatInputModule,
            MatFormFieldModule,
            MatListModule,
            MatMenuModule,
            MatNativeDateModule,
            MatPaginatorModule,
            MatProgressBarModule,
            MatProgressSpinnerModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSliderModule,
            MatSlideToggleModule,
            MatSnackBarModule,
            MatSortModule,
            MatTableModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatTreeModule,
            PortalModule,
            ScrollingModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [
                        A11yModule,
                        CdkStepperModule,
                        CdkTableModule,
                        CdkTreeModule,
                        DragDropModule,
                        MatAutocompleteModule,
                        MatBadgeModule,
                        MatBottomSheetModule,
                        MatButtonModule,
                        MatButtonToggleModule,
                        MatCardModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatStepperModule,
                        MatDatepickerModule,
                        MatDialogModule,
                        MatDividerModule,
                        MatExpansionModule,
                        MatGridListModule,
                        MatIconModule,
                        MatInputModule,
                        MatFormFieldModule,
                        MatListModule,
                        MatMenuModule,
                        MatNativeDateModule,
                        MatPaginatorModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSliderModule,
                        MatSlideToggleModule,
                        MatSnackBarModule,
                        MatSortModule,
                        MatTableModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatTreeModule,
                        PortalModule,
                        ScrollingModule,
                    ],
                }]
        }] });

class MyAngularGptPackageModule {
    static forRoot(jsonPath) {
        return {
            ngModule: MyAngularGptPackageModule,
            providers: [
                {
                    provide: 'CONFIG_PATH',
                    useValue: jsonPath
                },
                {
                    provide: ConfigService,
                    useFactory: async (configService, configPath, resourcesPath) => {
                        await configService.loadConfig(configPath, resourcesPath); // Load config file
                        return configService;
                    },
                    deps: [ConfigService, 'CONFIG_PATH']
                },
                DatePipe
            ]
        };
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageModule, declarations: [ChatComponent, MapComponent, AlertComponent, GptDialogComponent], imports: [MaterialModule, ReactiveFormsModule, FormsModule, NgxSpinnerModule, CommonModule, DragDropModule], exports: [ChatComponent, MapComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageModule, imports: [MaterialModule, ReactiveFormsModule, FormsModule, NgxSpinnerModule, CommonModule, DragDropModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.4", ngImport: i0, type: MyAngularGptPackageModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ChatComponent, MapComponent, AlertComponent, GptDialogComponent],
                    imports: [MaterialModule, ReactiveFormsModule, FormsModule, NgxSpinnerModule, CommonModule, DragDropModule], // Import HttpClientModule to load JSON
                    exports: [ChatComponent, MapComponent]
                }]
        }] });

/*
 * Public API Surface of my-angular-gpt-package
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ChatComponent, ConfigService, MapComponent, MyAngularGptPackageComponent, MyAngularGptPackageModule, MyAngularGptPackageService };
//# sourceMappingURL=my-angular-gpt-package.mjs.map
