import * as am5 from '@amcharts/amcharts5';
import { HttpClient } from '@angular/common/http';
import { NgZone } from "@angular/core";
import GraphicsLayer from '@arcgis/core/layers/GraphicsLayer';
import { ApplicationConfig } from '../../models/alert/configs/application-config';
import { ConfigService } from '../config/config.service';
import { ArcgisService } from '../arcgis/arcgis.service';
import { EventsService } from '../event/events.service';
import { AmChartsDataModel } from '../../models/charts/am-charts-data-model';
import * as i0 from "@angular/core";
export declare class ChartHelper {
    private platformId;
    private configService;
    private http;
    private arcgisService;
    private zone;
    private eventsService;
    config: ApplicationConfig;
    targetLayerConfig: any;
    graphicLayer: GraphicsLayer;
    constructor(platformId: any, configService: ConfigService, http: HttpClient, arcgisService: ArcgisService, zone: NgZone, eventsService: EventsService);
    browserOnly(f: () => void): void;
    barChartGeneration: (chartId: string, chartData: AmChartsDataModel[], xAxsisLabel: string, yAxsisLabel: string, allowChartZooming?: boolean, colorEachColunm?: boolean) => am5.Root;
    highlightBarChartReportColumn: (chartId: string, series: any, clickedFeatureKey: any) => void;
    lineChartGeneration: (chartId: string, chartData: AmChartsDataModel[], xAxsisLabel: string, yAxsisLabel: string, allowChartZooming?: boolean) => am5.Root;
    pieChartGeneration: (chartId: string, chartData: AmChartsDataModel[], xAxsisLabel: string, yAxsisLabel: string, allowChartZooming?: boolean, semiPieChart?: boolean) => am5.Root;
    sankeyChartGeneration: (chartId: string) => am5.Root;
    formatLargeNumberAbbreviation: (value: number) => string;
    formatNumber: (value: number) => string | number;
    capitalizeFirstLetter: (str: string) => string;
    groupChartsDataByKey: (data: AmChartsDataModel[], key: string, value: string, additionalProperties: any) => AmChartsDataModel[];
    static ɵfac: i0.ɵɵFactoryDeclaration<ChartHelper, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ChartHelper>;
}
