import { HttpClient } from '@angular/common/http';
import { ApplicationConfig } from '../../models/alert/configs/application-config';
import * as i0 from "@angular/core";
export declare class ConfigService {
    private http;
    config: ApplicationConfig;
    constructor(http: HttpClient);
    loadConfig(jsonPath: string, resourcesPath: string): Promise<void>;
    getResources(resourcesPath: string, lang: string): Promise<{}>;
    getLanguage(defaultLanguage: string): string;
    private fillResources;
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfigService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ConfigService>;
}
