import { ChangeDetectorRef, AfterViewInit } from '@angular/core';
import { EventsService } from '../../services/event/events.service';
import { ChatService } from '../../services/chat/chat.service';
import { ConfigService } from '../../services/config/config.service';
import { ArcgisService } from '../../services/arcgis/arcgis.service';
import * as i0 from "@angular/core";
export declare class ChatComponent implements AfterViewInit {
    private cdr;
    private arcgisService;
    private configService;
    private eventsService;
    chatService: ChatService;
    private chatBox;
    constructor(cdr: ChangeDetectorRef, arcgisService: ArcgisService, configService: ConfigService, eventsService: EventsService, chatService: ChatService);
    ngAfterViewInit(): void;
    sendMessage(): void;
    onKeyDown(event: KeyboardEvent): void;
    scrollToBottom(): void;
    deleteChat(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChatComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChatComponent, "app-chat", never, {}, {}, never, never, false, never>;
}
